<?php

/*
 * app.tpl
 *
 * @copyright     Copyright 2009-2012 Hamid Reza Samak
 * @link          http://www.limny.org
 * @package       limny
 * @author        Hamid Reza Samak <hamid@limny.org>
 * @license       GNU/GPL License (http://www.gnu.org/licenses/gpl.html)
 */

if (isset($_GET['p'][1]) === FALSE)
{
	header('Location: index.php');
	exit;
}

$app = $_GET['p'][1];

if (in_array($app, $class['admin']->installed_apps()) === FALSE)
{
	header('Location: index.php');
	exit;
}

$is_permitted = FALSE;

$class['user'] = new User;

if (isset($_GET['q']))
{
	if ($class['admin']->role_get_info('query', $class['user']->user_get_info('role')) == 'all')
		$is_permitted = TRUE;
	else
	{
		$result = $db->select('queries', array('id', 'query', 'sub'), array('app' => '=\'' . $db->escape($_GET['p'][1]) . '\'', 'AND', 'query' => '=\'' . $db->escape($_GET['q']) . '\''));
		if ($queries = $db->fetch_assoc($result))
			if (in_array($queries['id'], explode(',', $class['admin']->role_get_info('query', $class['user']->user_get_info('role')))))
				$is_permitted = TRUE;
		
		if ($is_permitted == FALSE)
		{
			$result = $db->select('queries', array('id', 'query'), array('app' => '=\'' . $db->escape($_GET['p'][1]) . '\'', 'AND', 'sub' => '=\'1\''));
			while ($queries = $db->fetch_assoc($result))
			{
				if (substr($_GET['q'], 0, strlen($queries['query']) + 1) === ($queries['query'] . '/'))
				{
					if (in_array($queries['id'], explode(',', $class['admin']->role_get_info('query', $class['user']->user_get_info('role')))))
						$is_permitted = TRUE;
					
					break;
				}
			}
		}
	}
}
else
{
	if ($class['admin']->role_get_info('query', $class['user']->user_get_info('role')) == 'all')
		$is_permitted = TRUE;
	else
	{
		$app_queries = array();
		$result = $db->select('queries', array('id'), array('app' => '=\'' . $db->escape($_GET['p'][1]) . '\''));
		while ($queries = $db->fetch_assoc($result))
			array_push($app_queries, $queries['id']);
		
		if (count(array_diff($app_queries, explode(',', $class['admin']->role_get_info('query', $class['user']->user_get_info('role'))))) < count($app_queries))
			$is_permitted = TRUE;
	}
}

unset($class['user']);

if ($is_permitted === TRUE)
{
	if (isset($_GET['q']))
	{
		$q = explode('/', $_GET['q']);
		$file = str_replace('\\', '', $q[0]);
		
		if ($app == $file || $q[0] == 'default')
		{
			header('Location: index.php?p=app/' . $app);
			exit;
		}
	}
	else
		$file = 'default';
	
	$app_path = '../apps/' . $app . '/admin';
	
	$class['admin']->load_language($app);
	
	if ($file != 'default' && file_exists($app_path . '/' . $file . '.tpl') === FALSE && file_exists($app_path . '/' . $file . '.php') === FALSE)
		$file = 'default';
		
	if (file_exists($app_path . '/' . $file . '.tpl'))
	{
		$php = $app_path . '/php/' . $file . '.php';
		if (file_exists($php))
			include $php;
		
		$content = file_get_contents($app_path . '/' . $file . '.tpl');
		
		$tpl = '';
		$content = explode('{', $content);
		foreach ($content as $value)
		{
			$value = explode('}', $value);
			$tpl .= (count($value) == 1) ? str_replace(array('\'', '&#123;', '&#125;'), array('\\\'', '{', '}'), $value[0]) : '\' . ' . $value[0] . ' . \'' . str_replace(array('\'', '&#123;', '&#125;'), array('\\\'', '{', '}'), $value[1]);
		}
		
		$tpl = eval('return \'' . $tpl . '\';');
		$page['content'] = isset($page['content']) ? $page['content'] . $tpl . "\n" : $tpl . "\n";
	}
	else if (file_exists($app_path . '/' . $file . '.php'))
	{
		ob_start();
		include($app_path . '/' . $file . '.php');
		$ob_contents = ob_get_contents();
		ob_end_clean();
		
		$page['content'] = isset($page['content']) ? $page['content'] . $ob_contents . "\n" : $ob_contents . "\n";
	}
	else
		limny_error('content unavailable for &quot;' . $app . '&quot; app.');
	
	if (file_exists($app_path . '/style.css'))
	{
		$css = '<link href="../apps/' . $app . '/admin/style.css" type="text/css" rel="stylesheet" />';
		$page['head'] = isset($page['head']) ? $page['head'] . $css . "\n" : $css . "\n";
	}
	
	if (file_exists($app_path . '/css/' . $file . '.css'))
	{
		$css = '<link href="../apps/' . $app . '/admin/css/' . $file . '.css" type="text/css" rel="stylesheet" />';
		$page['head'] = isset($page['head']) ? $page['head'] . $css . "\n" : $css . "\n";
	}
	
	if (file_exists($app_path . '/js/' . $file . '.js'))
	{
		$js = '<script type="text/javascript" src="../apps/' . $app . '/admin/js/' . $file . '.js"></script>';
		$page['head'] = isset($page['head']) ? $page['head'] . $js . "\n" : $js . "\n";
	}
}
else
	$page = array(
		'title' => PAGE_REQUEST_REFUSED,
		'content' => '<span class="warning">' . PAGE_REQUEST_REFUSED . '</span><br /><br />' . INFO_31
	);

?>