<?php

/*
 * apps.tpl
 *
 * @copyright     Copyright 2009-2012 Hamid Reza Samak
 * @link          http://www.limny.org
 * @package       limny
 * @author        Hamid Reza Samak <hamid@limny.org>
 * @license       GNU/GPL License (http://www.gnu.org/licenses/gpl.html)
 */

require '../incs/application.class.php';

$class['application'] = new Application;

function apps_list()
{
	$apps = array();
	
	$dir = opendir('../apps');
	while ($app = readdir($dir))
		if ($app != '.' && $app != '..' && is_dir('../apps/' . $app))
			array_push($apps, $app);
	
	closedir($dir);
	
	return $apps;
}

function app_is_installed($app, $ver = '')
{
	global $db;
	
	$result = $db->select('apps', array('id'), array('name' => '=\'' . $db->escape($app) . '\''));
	if ($apps = $db->fetch_assoc($result))
	{
		if (empty($ver) === FALSE)
		{
			$class['admin'] = new Admin;
			$info = $class['admin']->app_get_info($app);
			
			return ($ver == $info['version']) ? TRUE : FALSE;
		}
	}
	
	return FALSE;
}

if (isset($_GET['p'][1]))
{
	require('../incs/form.class.php');
	$class['form'] = new Form;
	
	$app = @$_GET['p'][2];
	
	if ($class['form']->validate_referer())
	{
		switch ($_GET['p'][1])
		{
			case 'reload':
				$installed_apps = $class['admin']->installed_apps();
				
				if (in_array($app, $installed_apps) && isset($_GET['p'][3]))
				{
					$update = TRUE;
					$enabled = ($_GET['p'][3] == '1') ? '1' : '0';
					
					if ($enabled == '1')
					{
						$info = $class['admin']->app_get_info($app);
						if (empty($info['dependedon']) === FALSE)
						{
							$depended_on = explode(',', $info['dependedon']);
							
							foreach ($depended_on as $value)
							{
								$name = substr($value, 0, strpos($value, '('));
								$version = substr($value, strpos($value, '(') + 1, strpos($value, ')') - strpos($value, '(') - 1);
								$dep_info = $class['admin']->app_get_info($name);
								
								if (in_array($name, $installed_apps) === FALSE || $class['admin']->get_app($name, 'enabled') != '1' || $dep_info['version'] != $version)
									$update = FALSE;
							}
							
							if ($update === TRUE)
							{
								foreach ($depended_on as $value)
								{
									$name = substr($value, 0, strpos($value, '('));
									
									$req_by = $class['admin']->get_app($name, 'reqby');
									$req_by = empty($req_by) ? array() : unserialize($req_by);
									array_push($req_by, $app);
									$req_by = serialize($req_by);
									
									$db->update('apps', array('reqby' => '\'' . $db->escape($req_by) . '\''), array('name' => '=\'' . $db->escape($name) . '\''));
								}
							}
						}
					}
					else
					{
						$info = $class['admin']->app_get_info($app);
						if (empty($info['dependedon']) === FALSE)
						{
							$depended_on = explode(',', $info['dependedon']);
							
							foreach ($depended_on as $value)
							{
								$name = substr($value, 0, strpos($value, '('));
								$version = substr($value, strpos($value, '(') + 1, strpos($value, ')') - strpos($value, '(') - 1);
								
								$req_by = $class['admin']->get_app($name, 'reqby');
								$req_by = unserialize($req_by);
								$req_by = array_diff($req_by, array($app));
								
								$req_by = (count($req_by) > 0 ) ? serialize($req_by) : '';
								
								$db->update('apps', array('reqby' => '\'' . $db->escape($req_by) . '\''), array('name' => '=\'' . $db->escape($name) . '\''));
							}
						}
					}
					
					if ($update === TRUE)
					{
						$updates = array('apps' => 'name', 'head' => 'app');
						
						foreach ($updates as $table => $column)
							$db->update($table, array('enabled' => '\'' . $enabled . '\''), array($column => '=\'' . $db->escape($app) . '\''));
					}
				}
			break;
			
			case 'install':
				if (in_array($app, apps_list()) && in_array($app, $class['admin']->installed_apps()) === FALSE)
				{
					if ($class['application']->is_compatible($app))
					{
						$db->insert('apps', array('name' => $db->escape($app), 'enabled' => '0'));
						
						if (file_exists('../apps/' . $app . '/' . $app . '.php'))
						{
							include '../apps/' . $app . '/' . $app . '.php';
							
							if (function_exists('install'))
								install();
						}
					}
				}
			break;
			
			case 'uninstall':
				if (isset($_POST['uninstall']) && isset($_POST['yes']))
				{
					if (strtoupper($_POST['yes']) === 'YES')
					{
						if (in_array($app, $class['admin']->installed_apps()))
						{
							if ($class['application']->is_enabled($app) === FALSE)
							{
								$db->delete('apps', array('name' => '=\'' . $app . '\''));
								
								if ($class['config']->content_default == 'app' && $class['config']->content_app == $app)
								{
									$db->update('config', array('value' => '\'\''), array('name' => '=\'content_app\''));
									$db->update('config', array('value' => '\'code\''), array('name' => '=\'content_default\''));
								}
								
								if (file_exists('../apps/' . $app . '/' . $app . '.php'))
								{
									include '../apps/' . $app . '/' . $app . '.php';
									
									if (function_exists('uninstall'))
										uninstall();
								}
							}
						}
					}
				}
			break;
		}
	}
	
	unset($class['form']);
}

$installed = '';
$uninstalled = '';
$num['installed'] = 1;
$num['uninstalled'] = 1;

$installed_apps = $class['admin']->installed_apps();

foreach (apps_list() as $app)
{
	$info = $class['admin']->app_get_info($app);
	
	if (in_array($app, $installed_apps))
	{
		$checked = ($class['application']->is_enabled($app)) ? ' checked="checked"' : NULL;
		
		$disabled = '';
		$depended_on = '';
		
		if (empty($info['dependedon']) === FALSE)
		{
			$for_checkbox = TRUE;
			$depended_on = array();
			foreach (explode(',', $info['dependedon']) as $value)
			{
				$dep_name = substr($value, 0, strpos($value, '('));
				$dep_version = substr($value, strpos($value, '(') + 1, strpos($value, ')') - strpos($value, '(') - 1);
				
				if (app_is_installed($dep_name, $dep_version))
				{
					$dep_info = $class['admin']->app_get_info($dep_name);
					array_push($depended_on, $dep_info['name'] . ' ' . $dep_version);
					unset($dep_info);
				}
				else
				{
					if (in_array($app, $installed_apps))
					{
						$dep_info = $class['admin']->app_get_info($dep_name);
						$dep_name = $dep_info['name'];
					}
					
					array_push($depended_on, $dep_name. ' ' . $dep_version);
				}
				
				if (app_is_installed($dep_name, $dep_version) === FALSE || $class['application']->is_enabled($dep_name) === FALSE)
					$for_checkbox = FALSE;
			}
			$depended_on = '<br /><br /><span class="light">(' . DEPENDED_ON . ': ' . implode(' &amp; ', $depended_on) . ')</span>';
			
			if ($for_checkbox === FALSE)
				$disabled = ' disabled="disabled"';
		}
		
		$req_by = $class['admin']->get_app($app, 'reqby');
		if (empty($req_by) === FALSE)
		{
			$required_by = array();
			
			foreach (unserialize($req_by) as $value)
			{
				$required_info = $class['admin']->app_get_info($value);
				array_push($required_by, $required_info['name'] . ' ' . $required_info['version']);
			}
			
			$required_by = '<br /><br /><span class="light">(' . REQUIRED_BY . ': ' . implode(' & ', $required_by) . ')</span>';
			$disabled = ' disabled="disabled"';
		}
		else
			$required_by = '';
		
		$odd_or_even = ($num['installed'] % 2) ? 'odd' : 'even';
		
		$installed .= '<div id="' . $app . '" class="row app ' . $odd_or_even . '">
		<div class="cell pad check"><input name="' . $app . '" type="checkbox" value="1"' . $checked . $disabled . ' /></div>
		<div class="cell pad name">' . $info['name'] . ' <span class="light">' . $info['version'] . '</span><div class="manage"><a href="#' . $app . '" class="uninstall" style="color: #EE0000;">[' . UNINSTALL . ']</a></div>' . $depended_on . $required_by . '</div>
		<div class="cell pad desc">' . $info['description'] . '</div>
	</div>';
		
		$num['installed']++;
	}
	else
	{
		$odd_or_even = ($num['uninstalled'] % 2) ? 'odd' : 'even';
		
		$uninstalled .= '<div class="row app ' . $odd_or_even . '">
		<div class="cell pad check"></div>
		<div class="cell pad name">' . $info['name'] . ' <span class="light">' . $info['version'] . '</span> ' . (($class['application']->is_compatible($app) === FALSE) ? '<span class="red">(' . NOT_COMPATIBLE . ')</span>' : NULL) . '<div class="manage"><a href="index.php?p=apps/install/' . $app . '" style="color: #009933;">[' . INSTALL . ']</a></div></div>
		<div class="cell pad desc">' . $info['description'] . '</div>
	</div>';
		
		$num['uninstalled']++;
	}
}

unset($app);
unset($num);
unset($info);

if (empty($installed))
{
	$installed = '<div class="row odd">
		<div class="cell pad"></div>
		<div class="cell pad light">' . INFO_7 . '</div>
		<div class="cell pad"></div>
	</div>';
}

if (empty($uninstalled))
{
	$uninstalled = '<div class="row odd">
		<div class="cell pad"></div>
		<div class="cell pad light">' . INFO_8 . '</div>
		<div class="cell pad"></div>
	</div>';
}

$page['title'] = APPLICATIONS;
$page['head'] = '<link href="table.css" type="text/css" rel="stylesheet" />
<link href="' . (($class['language']->direction == 'rtl') ? 'rtl/apps-rtl.css' : 'apps.css') . '" type="text/css" rel="stylesheet" />
<link href="' . (($class['language']->direction == 'rtl') ? 'rtl/form-rtl.css' : 'form.css') . '" type="text/css" rel="stylesheet" />
<link href="message.css" type="text/css" rel="stylesheet" />
<script type="text/javascript" src="apps.js"></script>';

$page['content'] = '<span class="title">' . APPLICATIONS . '</span>
<div class="table applications">
	<div class="row head">
		<div class="cell check"></div>
		<div class="cell name">' . NAME . '</div>
		<div class="cell desc">' . DESCRIPTION . '</div>
	</div>
	
	<div class="row">
		<div class="cell dash">-</div>
		<div class="cell subject">' . INSTALLED . '</div>
		<div class="cell"></div>
	</div>
	' . $installed . '
	<div class="row">
		<div class="cell dash">-</div>
		<div class="cell subject">' . READY_TO_INSTALL . '</div>
		<div class="cell"></div>
	</div>
	' . $uninstalled . '
</div>

<form id="uninstall" name="uninstall" action="index.php?p=apps/uninstall" method="post">
<div id="msgbox"></div>
<div id="msgcnt">
	<div style="font-weight: bold;">' . INFO_10 . '</div>
	<br />
	<div style="text-align: center">' . PLEASE_TYPE_YES_IN_THE_FIELD . ': <input name="yes" type="text" value="" size="5" class="yes" /></div>
	<br />
	<div style="text-align: center;"><input name="uninstall" type="submit" value="' . UNINSTALL . '" /> &nbsp; <a href="#" class="cancel">[' . NOPE . ']</a></div>
</div>
</form>';

unset($installed);
unset($uninstalled);

if (isset($update))
{
	print $page['content'];
	exit;
}

?>