<?php

/*
 * blocks.tpl
 *
 * @copyright     Copyright 2009-2012 Hamid Reza Samak
 * @link          http://www.limny.org
 * @package       limny
 * @author        Hamid Reza Samak <hamid@limny.org>
 * @license       GNU/GPL License (http://www.gnu.org/licenses/gpl.html)
 */

$theme = $class['config']->theme;
$info = file_get_contents('../themes/' . $theme . '/' . $theme . '.info');
unset($theme);

$data = explode("\r\n\r\n", $info);
unset($info);
$blocks = $data[2];
unset($data);
$blocks = explode("\r\n", $blocks);

$names = array();
foreach ($blocks as $line)
{
	$block = explode('|', $line);
	
	foreach ($block as $key => $widget)
	{
		if ($key == 0) $widget = substr($widget, 2, strlen($widget));
		array_push($names, strtolower(trim(substr($widget, 0, strpos($widget, '(')))));
	}
}

$widgets = '';
$result = $db->select('widgets', array('id', 'name', 'position'), array('1=1', 'ORDER BY', 'id' => 'ASC'));
while ($widget = $db->fetch_assoc($result))
{
	if ($widget['position'] == 'none' || in_array($widget['position'], $names) === FALSE)
	{
		$widgets .= '<div id="limny_widget_' . $widget['position'] . '_' . $widget['id'] . '" class="widget">
	<span class="name">' . $widget['name'] . '</span>
	<span class="status"><a href="index.php?p=widget/' . $widget['position'] . '/' . $widget['id'] . '" title="' . EDIT . '"><img border="0" width="24" height="24" src="../misc/transparent.gif" alt="transparent" style="background:url(\'../misc/custom-24.png\');" /></a></span>
	<div style="clear:both;"></div>
</div>';
	}
}

$page['content'] = '<div id="limny_block_none" class="widgets">
	<label>' . AVAILABLE_WIDGETS . ':</label>
	<br />
	' . $widgets . '
	<div style="clear:both;"></div>
</div>
<div style="width:100%;">';

unset($widgets);

foreach ($blocks as $line)
{
	$page['content'] .= '<div>';
	$block = explode('|', $line);
	
	foreach ($block as $key => $value)
	{
		if ($key == 0) $value = substr($value, 2, strlen($value));
		$name = strtolower(trim(substr($value, 0, strpos($value, '('))));
		$start_css = strpos($value, '(');
		$css = substr($value, $start_css + 1, strrpos($value, ')') - $start_css - 1);
		
		$widgets = '';
		$result = $db->select('widgets', array('id', 'name'), array('position' => '=\'' . $db->escape($name) . '\'', 'ORDER BY', 'id' => 'ASC'));
		while ($widget = $db->fetch_assoc($result))
		{
			$widgets .= '<div id="limny_widget_' . $name . '_' . $widget['id'] . '" class="widget">
	<span class="name">' . $widget['name'] . '</span>
	<span class="status"><a href="index.php?p=widget/' . $name . '/' . $widget['id'] . '" title="' . EDIT . '"><img border="0" width="24" height="24" src="../misc/transparent.gif" alt="transparent" style="background:url(\'../misc/custom-24.png\');" /></a></span>
	<div style="clear:both;"></div>
</div>';
		}
		
		$page['content'] .= '<div id="limny_block_' . $name . '" class="block" style="' . $css . '">' . $widgets . '</div>';
	}
	
	unset($start_css);
	unset($widgets);
	unset($block);
	unset($name);
	unset($css);
	
	$page['content'] .= '<div style="clear:both;"></div></div>';
}

$page['content'] .= '</div>';

$page['title'] = BLOCKS;
$page['head'] = '<link href="' . (($class['language']->direction == 'rtl') ? 'rtl/blocks-rtl.css' : 'blocks.css') . '" type="text/css" rel="stylesheet" />
<script type="text/javascript" src="../misc/jquery-ui.js"></script>
<script type="text/javascript" src="blocks.js"></script>';

?>