<?php

/*
 * config.tpl
 *
 * @copyright     Copyright 2009-2012 Hamid Reza Samak
 * @link          http://www.limny.org
 * @package       limny
 * @author        Hamid Reza Samak <hamid@limny.org>
 * @license       GNU/GPL License (http://www.gnu.org/licenses/gpl.html)
 */

if (isset($_POST['update']))
{
	require '../incs/form.class.php';
	$class['form'] = new Form;
	
	if (isset($_POST['site']))
		$db->update('config', array('value' => '\'' . $db->escape(unhtml($_POST['site'])) . '\''), array('name' => '=\'site\''));
		
	if ($class['form']->validate_referer())
	{
		if (isset($_POST['title']))
			$form['title'] = unhtml($_POST['title']);
		
		if (isset($_POST['header']))
			$form['header'] = unhtml($_POST['header']);
		
		$content = array('app', 'query', 'code');
		if (in_array($_POST['content'], $content))
		{
			if ($_POST['content'] == 'app')
			{
				$form['content_default'] = isset($_POST['app']) ? 'app' : $class['config']->content_default;
			}
			else
			{
				$form['content_default'] = $_POST['content'];
			}
		}
		
		unset($content);
		
		if ($form['content_default'] == 'app')
		{
			if (isset($_POST['app']))
			{
				$apps = $class['admin']->installed_apps();
				
				if (empty($apps) === FALSE)
				{
					foreach ($apps as $app)
					{
						if ($_POST['app'] == $app)
						{
							$form['content_app'] = $_POST['app'];
							break;
						}
					}
				}
				
				unset($apps);
			}
		}
		else if ($form['content_default'] == 'query')
		{
			if (isset($_POST['query']))
				$form['content_query'] = unhtml($_POST['query']);
		}
		else if ($form['content_default'] == 'code')
		{
			if (isset($_POST['code']))
				$form['content_code'] = $_POST['code'];
		}
		
		if (isset($_POST['uri_mode']))
		{
			if (in_array($_POST['uri_mode'], array('GET', 'REQUEST_URI')))
				$form['uri_mode'] = $_POST['uri_mode'];
		}
		
		if (isset($_POST['rewrite']))
			if (in_array($_POST['rewrite'], array('0', '1')))
				$form['rewrite'] = $_POST['rewrite'];
		
		if (isset($_POST['strip_tags']))
			$form['strip_tags'] = str_replace(array('&', '"'), array('&amp;', '&quot;'), $_POST['strip_tags']);
		
		if (isset($_POST['permalink']))
			if (in_array($_POST['permalink'], array('INCLUDE', 'REDIRECT')))
				$form['permalink'] = $_POST['permalink'];
		
		if (isset($_POST['registration']))
			if (in_array($_POST['registration'], array('0', '1')))
				$form['registration'] = $_POST['registration'];
		
		if (isset($_POST['cache']))
			if (in_array($_POST['cache'], array('0', '1')))
				$form['cache'] = $_POST['cache'];
		
		if (isset($_POST['cache_lifetime']))
			$form['cache_lifetime'] = (is_numeric($_POST['cache_lifetime']) && ceil($_POST['cache_lifetime']) > 0) ? ceil($_POST['cache_lifetime']) : '1';
		
		if (isset($_POST['email']))
			$form['email'] = unhtml($_POST['email']);
		
		foreach ($form as $key => $value)
			$db->update('config', array('value' => '\'' . $db->escape($value) . '\''), array('name' => '=\'' . $key . '\''));
		
		if (isset($form))
			unset($form);
	}
	
	unset($class['form']);
}


$result = $db->select('config', array('value'), array('name' => '=\'site\''));
$site = ($config = $db->fetch_assoc($result)) ? $config['value'] : $class['config']->site;

$title = $class['config']->title;
$header = $class['config']->header;

$checked = array(
	'app' => '',
	'query' => '',
	'code' => '',
	'GET' => '',
	'REQUEST_URI' => '',
	'rewrite_enable' => '',
	'rewrite_disable' => '',
	'INCLUDE' => '',
	'REDIRECT' => '',
	'registration_on' => '',
	'registration_off' => '',
	'cache_enable' => '',
	'cache_disable' => ''
);

$content_default = $class['config']->content_default;

if ($content_default == 'app')
{
	$checked['app'] = ' checked="checked"';
	
	$apps = '';
	foreach ($class['admin']->installed_apps() as $app)
	{
		$info = $class['admin']->app_get_info($app);
		$selected = ($app == $class['config']->content_app) ? ' selected="selected"' : NULL;
		
		$apps .= '<option value="' . $app . '"' . $selected . '>' . $info['name'] . '</option>';
	}
	
	unset($app);
	unset($selected);
	
	$content = array(
		'name' => APPLICATION . ':<br /><span class="desc">' . INFO_18 . '</span>',
		'field' => '<select name="app">' . $apps . '</select>'
	);
	
	unset($apps);
}
else if ($content_default == 'query')
{
	$checked['query'] = ' checked="checked"';
	
	$content = array(
		'name' => QUERY . ':<br /><span class="desc">' . INFO_19 . '</span>',
		'field' => '<input name="query" type="text" value="' . ($class['config']->content_query) . '" />'
	);
}
else if ($content_default = 'code')
{
	$checked['code'] = ' checked="checked"';
	
	$content = array(
		'name' => CODE . ':<br /><span class="desc">' . INFO_20 . '</span>',
		'field' => '<textarea name="code" rows="10" cols="50">' . unhtml($class['config']->content_code) . '</textarea>'
	);
}

unset($content_default);

$uri_mode = $class['config']->uri_mode;
if ($uri_mode == 'GET')
	$checked['GET'] = ' checked="checked"';
else if ($uri_mode == 'REQUEST_URI')
	$checked['REQUEST_URI'] = ' checked="checked"';
unset($uri_mode);

$rewrite = $class['config']->rewrite;
if ($rewrite == '1')
	$checked['rewrite_enable'] = ' checked="checked"';
else if ($rewrite == '0')
	$checked['rewrite_disable'] = ' checked="checked"';
unset($rewrite);

$strip_tags = str_replace(array('<', '>'), array('&lt;', '&gt;'), $class['config']->strip_tags);

$permalink = $class['config']->permalink;
if ($permalink == 'INCLUDE')
	$checked['INCLUDE'] = ' checked="checked"';
else if ($permalink == 'REDIRECT')
	$checked['REDIRECT'] = ' checked="checked"';
unset($permalink);

$registration = $class['config']->registration;
if ($registration == '1')
	$checked['registration_on'] = ' checked="checked"';
else if ($registration == '0')
	$checked['registration_off'] = ' checked="checked"';
unset($registration);

$cache = $class['config']->cache;
if ($cache == '1')
	$checked['cache_enable'] = ' checked="checked"';
else if ($cache == '0')
	$checked['cache_disable'] = ' checked="checked"';
unset($cache);

$cache_size = 0;
foreach (scandir(__PATH__ . '/cache') as $cache_file)
	if (in_array($cache_file, array('.', '..', '.htaccess', 'index.html')) === FALSE)
		$cache_size += filesize(__PATH__ . '/cache/' . $cache_file);
unset($cache_file);

if ($cache_size > 0)
	$cache_size = '<br /><br /><span class="desc">' . CACHE_SIZE . ': ' . round($cache_size / 1000, 2) . ' kB <a href="#" title="' . INFO_56 . '" class="clear">[' . CLEAR . ']</a></span>';
else
	$cache_size = NULL;

$configuration = '<form name="configuration" action="index.php?p=config" method="post">
<span class="title">' . GENERAL . '</span>
<div class="configuration table">
	<div class="row">
		<div class="cell name">' . TITLE . ':</div>
		<div class="cell field"><input name="title" type="text" value="' . $title . '" /></div>
	</div>
	<div class="row">
		<div class="cell name">' . HEADER . ':</div>
		<div class="cell field"><input name="header" type="text" value="' . $header . '" /></div>
	</div>
	<div class="row">
		<div class="cell name">' . SITE . ':<br /><span class="desc">' . FOR_EXAMPLE . ' http://domain-name/path</span></div>
		<div class="cell field"><input name="site" type="text" value="' . $site . '" size="40" /></div>
	</div>
</div>
<br />
<br />
<br />
<span class="title">' . CONTENT . '</span>
<div class="configuration table">
	<div class="row">
		<div class="cell name">' . CONTENT . ':<br /><span class="desc">' . INFO_17 . '</span></div>
		<div class="cell field contenttype"><label id="app"><input name="content" type="radio" value="app"' . $checked['app'] . ' /> ' . APPLICATION . '</label> &nbsp; <label id="query"><input name="content" type="radio" value="query"' . $checked['query'] . ' /> ' . QUERY . '</label> &nbsp; <label id="code"><input name="content" type="radio" value="code"' . $checked['code'] . ' /> ' . CODE . '</label></div>
	</div>
	<div class="row">
		<div class="cell name contentname">' . $content['name'] . '</div>
		<div class="cell field contentfield">' . $content['field'] . '</div>
	</div>
</div>
<br />
<br />
<br />
<span class="title">' . SETTINGS . '</span>
<div class="configuration table">
	<div class="row">
		<div class="cell name">' . URI_MODE . ':<br /><span class="desc">' . INFO_14 . '</span></div>
		<div class="cell field"><label><input name="uri_mode" type="radio" value="GET"' . $checked['GET'] . ' /> ' . GET . '</label><span class="desc">' . ($class['config']->site . '/index.php?q=hello') . '</span><br /><br /><label><input name="uri_mode" type="radio" value="REQUEST_URI"' . $checked['REQUEST_URI'] . ' /> ' . REQUEST_URI . '</label><span class="desc">' . ($class['config']->site . '/index.php/hello') . '</span></div>
	</div>
	<div class="row">
		<div class="cell name">' . REWRITE . ': <br /><span class="desc">' . INFO_16 . '</span></div>
		<div class="cell field"><label><input name="rewrite" type="radio" value="1"' . $checked['rewrite_enable'] . ' /> ' . ENABLE . '</label> &nbsp; <label><input name="rewrite" type="radio" value="0"' . $checked['rewrite_disable'] . ' /> ' . DISABLE . '</label></div>
	</div>
	<div class="row">
		<div class="cell name">' . ALLOWED_HTML_TAGS . ':<br /><span class="desc">' . INFO_13 . '<br />' . FOR_EXAMPLE . ' &lt;a&gt;&lt;b&gt;&lt;i&gt;&lt;u&gt;</span></div>
		<div class="cell field"><input name="strip_tags" type="text" value="' . $strip_tags . '" /></div>
	</div>
	<div class="row">
		<div class="cell name">' . PERMALINK . ': <br /><span class="desc">' . INFO_15 . '</span></div>
		<div class="cell field"><label><input name="permalink" type="radio" value="INCLUDE"' . $checked['INCLUDE'] . ' /> ' . INCLUDE_SOURCE_IN_PERMALINK_PAGE . '</label><br /><br /><label><input name="permalink" type="radio" value="REDIRECT"' . $checked['REDIRECT'] . ' /> ' . REDIRECT_TO_SOURCE_PAGE . '</label></div>
	</div>
	<div class="row">
		<div class="cell name">' . REGISTRATION . ': <br /><span class="desc">' . INFO_4 . '</span></div>
		<div class="cell field"><label><input name="registration" type="radio" value="1"' . $checked['registration_on'] . ' /> ' . _ON_ . '</label> &nbsp; <label><input name="registration" type="radio" value="0"' . $checked['registration_off'] . ' /> ' . OFF . '</label></div>
	</div>
	<div class="row">
		<div class="cell name">' . CACHE . ':<br /><span class="desc">' . INFO_54 . '</span></div>
		<div class="cell field"><label><input name="cache" type="radio" value="1"' . $checked['cache_enable'] . ' /> ' . ENABLE . '</label> &nbsp; <label><input name="cache" type="radio" value="0"' . $checked['cache_disable'] . ' /> ' . DISABLE . '</label>' . $cache_size . '</div>
	</div>
	<div class="row">
		<div class="cell name">' . CACHE_LIFETIME . ':<br /><span class="desc">' . INFO_55 . '</span></div>
		<div class="cell field"><input name="cache_lifetime" type="text" value="' . $class['config']->cache_lifetime . '" /></div>
	</div>
	<div class="row">
		<div class="cell name">' . EMAIL . ':</div>
		<div class="cell field"><input name="email" type="text" value="' . $class['config']->email . '" /></div>
	</div>
</div>
<div class="buttons"><input name="update" type="submit" value="' . UPDATE . '" /> &nbsp; <a href="index.php">[' . BACK . ']</a></div>
</form>';

unset($title);
unset($header);
unset($site);
unset($checked);
unset($strip_tags);

$page['title'] = CONFIGURATION;
$page['head'] = '<link href="' . (($class['language']->direction == 'rtl') ? 'rtl/config-rtl.css' : 'config.css') . '" type="text/css" rel="stylesheet" />
<link href="table.css" type="text/css" rel="stylesheet" />
<link href="' . (($class['language']->direction == 'rtl') ? 'rtl/form-rtl.css' : 'form.css') . '" type="text/css" rel="stylesheet" />
<script type="text/javascript" src="config.js"></script>';
$page['content'] = $configuration;

unset($configuration);

?>