<?php

/*
 * index.php
 *
 * @copyright     Copyright 2009-2012 Hamid Reza Samak
 * @link          http://www.limny.org
 * @package       limny
 * @author        Hamid Reza Samak <hamid@limny.org>
 * @license       GNU/GPL License (http://www.gnu.org/licenses/gpl.html)
 */

require 'init.php';

if (isset($_GET['p']))
{
	$_GET['p'] = explode('/', $_GET['p']);
	
	if ($_GET['p'][0] == 'app' || $class['admin']->is_permitted($_GET['p'][0]))
		include $_GET['p'][0] . '.tpl';
	else
		$page = array(
			'title' => PAGE_REQUEST_REFUSED,
			'content' => '<span class="warning">' . PAGE_REQUEST_REFUSED . '</span><br /><br />' . INFO_31
		);
}
else
	include 'default.tpl';

?><!DOCTYPE html>
<html dir="<?php print $class['language']->direction; ?>">
<head>
<title><?php if (empty($page['title']) === FALSE) print $page['title'] . ' - '; print LIMNY; ?></title>
<meta http-equiv="Content-Type" content="text/html; charset=<?php print $class['language']->charset; ?>" />
<meta name="generator" content="Limny <?php print $class['config']->version; ?>" />
<link href="<?php print ($class['language']->direction == 'rtl') ? 'rtl/style-rtl.css' : 'style.css'; ?>" type="text/css" rel="stylesheet" />
<link rel="shortcut icon" href="<?php print base_path(); ?>/misc/favicon.ico" type="image/x-icon" />
<script type="text/javascript" src="../misc/jquery.js"></script>
<script type="text/javascript" src="script.js"></script>
<?php if (empty($page['head']) === FALSE) print $page['head']; ?>
</head>
<body>
<?php

$class['user'] = new User;
$class['config'] = new Config;

$admin = unserialize($class['config']->admin);
$privileges = $class['admin']->role_get_info('admin', $class['user']->user_get_info('role'));
$privileges = empty($privileges) ? array() : explode(',', $privileges);

if (count($privileges) > 0)
{
	$icon = array('block', 'widget', 'language', 'application', 'appearance', 'configuration', 'role');
	
	if ($privileges[0] == 'all')
		$privileges = array(1, 2, 3, 4, 5, 6, 7);
	
	$items = '<ul>';
	foreach ($privileges as $value)
	{
		$url = explode(',', $admin[$value][1]);
		$name = eval('return ' . $admin[$value][0] . ';');
		
		$items .= '<li><a href="index.php?p=' . $url[0] . '"><img src="../misc/' . $icon[$value - 1] . '-16.png" alt="' . $name . '" />' . $name . '</a></li>';
	}
	$items .= '</ul>';
	
	unset($url);
	unset($name);
	unset($icon);
}

?>
<div id="nav">
	<?php if (isset($items)) print $items; ?>
	<div id="home">
		<a href="<?php print $class['config']->site; ?>" title="<?php print MAIN_PAGE; ?>" target="_blank"><img src="../misc/web-16.png" alt="<?php print LIMNY; ?>" /></a>
		<a href="<?php print base_path() . '/admin'; ?>" title="<?php print ADMINISTRATION; ?>"><img src="../misc/home-16.png" alt="<?php print LIMNY; ?>" /></a>
	</div>
	<div style="clear:both;"></div>
</div>
<div id="header">
	<div id="title"><a href="<?php print $class['config']->site . '/admin'; ?>"><?php print $class['config']->title; ?></a></div>
	<div id="user">
		<ul class="horizontal">
			<li><label><?php print $_SESSION['_user']; ?></label></li>
			<li>|</li>
			<li><a href="<?php print url('-/logout', TRUE); ?>"><?php print LOGOUT; ?></a></li>
		</ul>
	</div>
	<div style="clear:both;"></div>
</div>
<div id="wrapper">
	<div id="sidebar">
<?php

$installed_apps = $class['admin']->installed_apps();

if (count($installed_apps) > 0)
{
	$count = count($installed_apps);
	
	print '<ul class="apps">';
	
	foreach ($installed_apps as $key => $value)
	{
		if ($count == 1)
			$cls = 'alone';
		else
		{
			if ($key == 0)
				$cls = 'first';
			else if ($key == $count - 1)
				$cls = 'last';
			else
				$cls = 'item';
		}
		
		$icon = file_exists('../apps/' . $value . '/icon.png') ? ' ../apps/' . $value . '/icon.png' : '../misc/application-32.png';
		
		$display = '';
		$features = '';
		
		if (isset($_GET['p']))
		{
			if ($_GET['p'][0] == 'app' && $_GET['p'][1] == $value)
			{
				$display = ' style="display:block;"';
				
				if (file_exists('../apps/' . $app . '/' . $app . '.php'))
				{
					include '../apps/' . $app . '/' . $app . '.php';
					if (function_exists('features'))
					{
						$class['admin']->load_language($app);
						
						$serutaef = features();
						
						if (is_array($serutaef))
						{
							$features = '<ul class="features">';
							foreach ($serutaef as $fkey => $fvalue)
								$features .= '<li><a href="' . $fvalue . '">' . $fkey . '</a></li>';
							$features .= '</ul>';
						}
						else
							$features = $serutaef;
					}
				}
			}
		}
		
		$app_info = $class['admin']->app_get_info($value);
		
		print '<li id="app_' . $value . '" class="app ' . $cls . '" style="background-image: url(' . $icon . ');"><a href="index.php?p=app/' . $value . '">' . $app_info['name'] . '</a><div class="features"' . $display . '>' . $features . '</div></li>';
	}
	
	unset($display);
	unset($features);
	
	print '</ul>';
}
else
	print '<div class="getanapp"><a href="http://www.limny.org/get-app">' . GET_AN_APP . '</a></div>';

?>
	</div>
	<div id="content"><?php if (empty($page['content']) === FALSE) print $page['content']; ?></div>
</div>
<div style="clear:both;"></div>
<div id="footer"><a href="http://www.limny.org" title="Powered by Limny"><img alt="Powered by Limny" src="../misc/limny-button.png" /></a></div>
</body>
</html>