<?php

/*
 * langs.tpl
 *
 * @copyright     Copyright 2009-2012 Hamid Reza Samak
 * @link          http://www.limny.org
 * @package       limny
 * @author        Hamid Reza Samak <hamid@limny.org>
 * @license       GNU/GPL License (http://www.gnu.org/licenses/gpl.html)
 */

if (isset($_GET['p'][1]) && isset($_GET['p'][2]))
{
	if ($_GET['p'][1] == 'install')
	{
		$dir = opendir('../langs');
		while ($lang = readdir($dir))
		{
			if (in_array($lang, array('.', '..')) === FALSE && is_dir('../langs/' . $lang))
			{
				if (in_array($_GET['p'][2], $class['language']->languages('value')) === FALSE)
				{
					$file = file_get_contents('../langs/' . $_GET['p'][2] . '/' . $_GET['p'][2] . '.info');
					$line = explode("\n", $file);
					$info = array();
					
					for ($i = 2; $i < count($line); $i++)
					{
						if (empty($line[$i]) === FALSE)
						{
							$item = explode('=', $line[$i]);
							$info[trim($item[0])] = trim($item[1]);
						}
					}
					
					unset($line);
					unset($file);
					
					$db->insert('languages', array('name' => $db->escape($info['name']), 'value' => $db->escape($info['value']), 'direction' => $db->escape($info['direction']), 'charset' => $db->escape($info['charset'])));
					
					unset($info);
					break;
				}
			}
		}
		
		if (isset($lang))
			unset($lang);
	}
	else if ($_GET['p'][1] == 'uninstall')
	{
		if (in_array($_GET['p'][2], $class['language']->languages('value')))
		{
			if ($class['config']->language != $_GET['p'][2])
			{
				$db->delete('languages', array('value' => '=\'' . $db->escape($_GET['p'][2]) . '\''));
				$db->update('users', array('language' => '\'\''), array('language' => '=\'' . $db->escape($_GET['p'][2]) . '\''));
			}
		}
	}
	else if ($_GET['p'][1] == 'setasdefault')
	{
		if (in_array($_GET['p'][2], $class['language']->languages('value')))
			$db->update('config', array('value' => '\'' . $db->escape($_GET['p'][2]) . '\''), array('name' => '=\'language\''));
	}
}

$installed = '';
$uninstalled = '';
$num['installed'] = 1;
$num['uninstalled'] = 1;

$dir = opendir('../langs');
while ($lang['value'] = readdir($dir))
{
	if (in_array($lang['value'], array('.', '..')) === FALSE && is_dir('../langs/' . $lang['value']))
	{
		$lang['content'] = file_get_contents('../langs/' . $lang['value'] . '/' . $lang['value'] . '.info');
		$line = explode("\n", $lang['content']);
		$info = array();
		
		for ($i = 2; $i < count($line); $i++)
		{
			if (empty($line[$i]) === FALSE)
			{
				$item = explode('=', $line[$i]);
				$info[trim($item[0])] = trim($item[1]);
			}
		}
		
		unset($line);
		
		if (in_array($lang['value'], $class['language']->languages('value')))
		{
			$default = ($class['config']->language == $lang['value']) ? ' <span class="light">(' . _DEFAULT_ . ')</span>' : NULL;
			$setasdefault = ($class['config']->language != $lang['value']) ? '<a href="index.php?p=langs/setasdefault/' . $lang['value'] . '" style="color: #FFA500;">[' . SET_AS_DEFAULT . ']</a> &nbsp; ' : NULL;
			
			$odd_or_even = ($num['installed'] % 2) ? 'odd' : 'even';
			$installed .= '<div id="' . $lang['value'] . '" class="row lang ' . $odd_or_even . '">
		<div class="cell pad name"><img src="../misc/transparent.gif" alt="' . $info['name'] . '" class="flag" style="background-image: url(../langs/' . $lang['value'] . '/' . $lang['value'] . '.png);" />' . $info['name'] . $default . '<div class="manage">' . $setasdefault . '<a href="#' . $lang['value'] . '" class="uninstall" style="color: #EE0000;">[' . UNINSTALL . ']</a></div></div>
		<div class="cell pad desc">' . $info['description'] . '</div>
	</div>';
			$num['installed']++;
		}
		else
		{
			$odd_or_even = ($num['uninstalled'] % 2) ? 'odd' : 'even';
			$uninstalled .= '<div class="row lang ' . $odd_or_even . '">
		<div class="cell pad name"><img src="../misc/transparent.gif" alt="' . $info['name'] . '" class="flag" style="background-image:url(../langs/' . $lang['value'] . '/' . $lang['value'] . '.png);" />' . $info['name'] . '<div class="manage"><a href="index.php?p=langs/install/' . $lang['value'] . '" style="color: #009933;">[' . INSTALL . ']</a></div></div>
		<div class="cell pad desc">' . $info['description'] . '</div>
	</div>';
			$num['uninstalled']++;
		}
	}
}
closedir($dir);

if (empty($installed))
	$installed = '<div class="row odd">
		<div class="cell pad light">' . INFO_28 . '</div>
		<div class="cell pad"></div>
	</div>';

if (empty($uninstalled))
	$uninstalled = '<div class="row odd">
		<div class="cell pad light">' . INFO_29 . '</div>
		<div class="cell pad"></div>
	</div>';

$page['title'] = LANGUAGES;
$page['head'] = '<link href="table.css" type="text/css" rel="stylesheet" />
<link href="' . (($class['language']->direction == 'rtl') ? 'rtl/langs-rtl.css' : 'langs.css') . '" type="text/css" rel="stylesheet" />
<link href="' . (($class['language']->direction == 'rtl') ? 'rtl/form-rtl.css' : 'form.css') . '" type="text/css" rel="stylesheet" />
<link href="message.css" type="text/css" rel="stylesheet" />
<script type="text/javascript" src="langs.js"></script>';

$page['content'] = '<span class="title">' . LANGUAGES . '</span>
<div class="table languages">
	<div class="row head">
		<div class="cell name">' . NAME . '</div>
		<div class="cell desc">' . DESCRIPTION . '</div>
	</div>
	
	<div class="row">
		<div class="cell subject">- ' . INSTALLED . '</div>
		<div class="cell"></div>
	</div>
	' . $installed . '
	<div class="row">
		<div class="cell subject">- ' . READY_TO_INSTALL . '</div>
		<div class="cell"></div>
	</div>
	' . $uninstalled . '
</div>

<form id="uninstall" name="uninstall" action="index.php?p=langs/uninstall" method="post">
<div id="msgbox"></div>
<div id="msgcnt">
	<div style="font-weight: bold;">' . INFO_30 . '</div>
	<br />
	<div style="text-align: center">' . PLEASE_TYPE_YES_IN_THE_FIELD . ': <input name="yes" type="text" value="" size="5" class="yes" /></div>
	<br />
	<div style="text-align: center;"><input name="uninstall" type="submit" value="' . UNINSTALL . '" /> &nbsp; <a href="#" class="cancel">[' . NOPE . ']</a></div>
</div>
</form>';

unset($installed);
unset($uninstalled);

?>