<?php

/*
 * preview.php
 *
 * @copyright     Copyright 2009-2012 Hamid Reza Samak
 * @link          http://www.limny.org
 * @package       limny
 * @author        Hamid Reza Samak <hamid@limny.org>
 * @license       GNU/GPL License (http://www.gnu.org/licenses/gpl.html)
 */

require '../init.php';

session_name('_limny');
session_start();

require 'admin.class.php';
require '../incs/user.class.php';
require '../incs/config.class.php';

$class['admin'] = new Admin;
$class['admin']->check_session();

if ($class['admin']->is_permitted('appearance') === FALSE)
{
	header('Location: index.php');
	exit;
}

if (isset($_GET['theme']) === FALSE)
{
	header('Location: index.php');
	exit;
}

if (in_array($_GET['theme'], $class['admin']->installed_themes()) === FALSE)
{
	header('Location: index.php');
	exit;
}

include __PATH__ . '/incs/role.class.php';
include __PATH__ . '/incs/language.class.php';
include __PATH__ . '/incs/page.class.php';
include __PATH__ . '/incs/application.class.php';
include __PATH__ . '/incs/cache.class.php';
include __PATH__ . '/incs/content.class.php';
include __PATH__ . '/incs/widget.class.php';
include __PATH__ . '/incs/permalink.class.php';

$class['config'] = new Config;
$class['language'] = new Language;

$theme = $class['config']->theme;
$db->update('config', array('value' => '\'' . $db->escape($_GET['theme']) . '\''), array('name' => '=\'theme\''));

include_once __PATH__ . '/langs/'.$class['language']->language.'/main.php';

$class['page'] = new Page;
$class['page']->make();
print $class['page']->_page;

$db->update('config', array('value' => '\'' . $db->escape($theme) . '\''), array('name' => '=\'theme\''));

?>