<?php

/*
 * role.tpl
 *
 * @copyright     Copyright 2009-2012 Hamid Reza Samak
 * @link          http://www.limny.org
 * @package       limny
 * @author        Hamid Reza Samak <hamid@limny.org>
 * @license       GNU/GPL License (http://www.gnu.org/licenses/gpl.html)
 */

function get_query_name($query)
{
	global $db;
	
	if (is_numeric($query))
	{
		$result = $db->select('queries', array('app', 'name'), array('id' => '=\'' . $query . '\''));
		if ($query = $db->fetch_assoc($result))
		{
			$class['language'] = new Language;
			$file = '../apps/' . $query['app'] . '/admin/langs/' . $class['language']->language . '.php';
			
			if (file_exists($file))
			{
				ob_start();
				include($file);
				$name = eval('return Q_' . $query['name'] . ';');
				ob_end_clean();
				
				return $name;
			}
			
			return $query['name'];
		}
	}
	
	return false;
}

if (isset($_GET['p'][1]) === FALSE)
{
	header('Location: index.php');
	exit;
}

if (is_numeric($_GET['p'][1]) === FALSE)
{
	header('Location: index.php');
	exit;
}

require '../incs/form.class.php';
require '../incs/role.class.php';

$class['form'] = new Form;
$class['role'] = new Role;

if (isset($_POST['update']) && $class['form']->validate_referer())
{
	$result = $db->select('roles', array('admin'), array('id' => '=\'' . $_GET['p'][1] . '\'', 'AND', 'query' => 'IS NULL', 'AND', 'admin' => 'IS NULL'));
	if ($role = $db->fetch_assoc($result))
	{
		$list = array();
		$result = $db->select('queries', array('id'));
		while ($queries = $db->fetch_assoc($result))
			if (isset($_POST['query_' . $queries['id']]))
				array_push($list, $queries['id']);
		
		$db->update('roles', array('query' => '\'' . $db->escape(implode(',', $list)) . '\''), array('id' => '=\'' . $_GET['p'][1] . '\''));
		
		$list = array();
		$admin = unserialize($class['config']->admin);
		foreach ($admin as $key => $value)
			if (isset($_POST['admin_' . $value[0]]))
				array_push($list, $key);
		
		$db->update('roles', array('admin' => '\'' . $db->escape(implode(',', $list)) . '\''), array('id' => '=\'' . $_GET['p'][1] . '\''));
		
		unset($list);
		unset($admin);
	}
}

$result = $db->select('roles', '*', array('id' => '=\'' . $_GET['p'][1] . '\''));
if ($role = $db->fetch_assoc($result))
{
	if (isset($_GET['p'][2]) && $class['form']->validate_referer() && $role['id'] != 1)
	{
		if ($_GET['p'][2] == 'delete' && strtoupper($_POST['yes']) == 'YES')
		{
			$db->delete('roles', array('id' => '=\'' . $role['id'] . '\''));
			$db->delete('users', array('role' => '=\'' . $role['id'] . '\''));
			
			header('Location: index.php?p=usersroles');
			exit;
		}
		else if ($_GET['p'][2] == 'move' && isset($_POST['role']) )
		{
			if (isset($_POST['role']))
			{
				if (in_array($_POST['role'], $class['role']->roles('id')))
				{
					$db->update('users', array('role' => '\'' . $db->escape($_POST['role']) . '\''), array('role' => '=\'' . $role['id'] . '\''));
					
					header('Location: index.php?p=usersroles');
					exit;
				}
			}
		}
	}
	
	$admin = unserialize($class['config']->admin);
	$role_query = explode(',', $role['query']);
	
	$content = '<a href="index.php?p=usersroles"><img src="../misc/user-16.png" alt="' . USERS_AND_ROLES . '" style="vertical-align:middle;" /> ' . USERS_AND_ROLES . '</a> &#8250; ' . ROLE . ': ' . $role['name'] . ' &nbsp; <span class="tabs"><span class="applications">' . APPLICATIONS . '</span> | <span class="administration"><a href="#admin">' .ADMINISTRATION . '</a></span></span><br /><br /><br /><form name="update" action="index.php?p=role/' . $_GET['p'][1] . '" method="post">';
	
	$disabled = ($role['admin'] == 'all') ? ' disabled="disabled"' : NULL;
	$apps = $class['admin']->installed_apps();
	
	if (empty($apps) === FALSE)
	{
		foreach ($apps as $app)
		{
			$result = $db->select('queries', array('id'), array('app' => '=\'' . $db->escape($app) . '\''));
			if ($db->num_rows($result) > 0)
			{
				$info = $class['admin']->app_get_info($app);
				$icon = (file_exists('../apps/' . $app . '/icon.png')) ? '../apps/' . $app . '/icon.png' : '../misc/application-32.png';
				$content .= '<div class="app"><span class="app" style="background-image: url(' . $icon . ');">' . $info['name'] . '</span>';
				$content .= '<div class="table">';
				
				while ($queries = $db->fetch_assoc($result))
				{
					$checked = ($role['admin'] == 'all' || in_array($queries['id'], $role_query)) ? ' checked="checked"' : NULL;
					$content .= '<div class="row privilege"><div class="cell name">' . get_query_name($queries['id']) . '</div><div class="cell check"><input name="query_' . $queries['id'] . '" type="checkbox" value="1"' . $checked . ' ' . $disabled . ' /></div></div>';
				}
				
				$content .= '</div></div>';
			}
		}
	}
	else
		$content .= '<div class="app"><div class="table"><div class="row privilege"><div class="cell noapp">' . INFO_5 . '</div></div></div></div>';
	
	$content .= '<div class="admin"><div class="table"><div class="row title"><div class="cell">' . ADMINISTRATION . '</div><div class="cell">' . PRIVILEGE . '</div></div>';
	
	$icon = array(1 => 'block', 'widget', 'language', 'application', 'appearance', 'configuration', 'role');
	foreach ($admin as $key => $value)
	{
		$checked = ($role['admin'] == 'all' || in_array($key, explode(',', $role['admin']))) ? ' checked="checked"' : '';
		$content .= '<div class="row privilege"><div class="cell name" style="background-image:url(../misc/' . $icon[$key] . '-16.png);">' . eval('return ' . $value[0] . ';') . '</div><div class="cell check"><input name="admin_' . $value[0] . '" type="checkbox" value="1"' . $checked .' ' . $disabled . ' /></div></div>';
	}
	
	$content .= '</div></div>';
	
	$roles = '';
	foreach ($class['role']->roles() as $value)
	{
		$selected = ($value['id'] == $role['id']) ? ' selected="selected"' : '';
		$roles .= '<option value="' . $value['id'] . '"' . $selected . '>' . $value['name'] . '</option>';
	}
	
	$content .= '<div class="buttons"><input name="update" type="submit" value="' . UPDATE . '" /> &nbsp; <a href="index.php?p=usersroles" title="' . BACK . '">[' . BACK . ']</a> &nbsp; <a href="index.php?p=role/' . $_GET['p'][1] . '" class="delete" title="' . DELETE . '"><img alt="' . DELETE . '" src="../misc/transparent.gif" align="absmiddle" style="width:32px; height:32px; background: url(../misc/delete-32.png) no-repeat center;" /></a> &nbsp; <a href="index.php?p=role/' . $_GET['p'][1] . '" class="move" title="' . MOVE_USERS . '"><img alt="' . MOVE_USERS . '" src="../misc/transparent.gif" align="absmiddle" style="width:32px; height:32px; background: url(../misc/moveuser-32.png) no-repeat center;" /></a></div></form>

<div class="delete">
<form name="delete" action="index.php?p=role/' . $_GET['p'][1] . '/delete" method="post"><div id="msgbox"></div>
<div id="msgcnt">
	<div style="font-weight: bold;"><span style="color:#DD0000;">' . IMPORTANT_NOTICE . ': </span><br />' . INFO_32 . '</div>
	<div style="text-align: center">' . PLEASE_TYPE_YES_IN_THE_FIELD . ': <input name="yes" type="text" value="" size="5" class="yes" /></div>
	<br />
	<div style="text-align: center;"><input name="delete" type="submit" value="' . DELETE . '" /> &nbsp; <a href="#" class="cancel">[' . NOPE . ']</a></div>
</div></form>
</div>

<div class="move">
<form name="move" action="index.php?p=role/' . $_GET['p'][1] . '/move" method="post"><div id="msgbox" class="move"></div>
<div id="msgcnt">
	<div style="font-weight: bold;">' . MOVE_USERS_TO . ':</div>
	<br />
	<div style="text-align: center"><select name="role">' . $roles . '</select></div>
	<br />
	<br />
	<div style="text-align: center;"><input name="move" type="submit" value="' . MOVE . '" /> &nbsp; <a href="#" class="cancel">[' . NOPE . ']</a></div>
</div></form>
</div>';
	
	$page['title'] = ROLE . ': ' . $role['name'];
	$page['head'] = '<link href="' . (($class['language']->direction == 'rtl') ? 'rtl/role-rtl.css' : 'role.css') . '" type="text/css" rel="stylesheet" />
<link href="table.css" type="text/css" rel="stylesheet" />
<link href="message.css" type="text/css" rel="stylesheet" />
<link href="' . (($class['language']->direction == 'rtl') ? 'rtl/form-rtl.css' : 'form.css') . '" type="text/css" rel="stylesheet" />
<script type="text/javascript" src="role.js"></script>';
	$page['content'] = $content;
}

?>