<?php

/*
 * styles.tpl
 *
 * @copyright     Copyright 2009-2012 Hamid Reza Samak
 * @link          http://www.limny.org
 * @package       limny
 * @author        Hamid Reza Samak <hamid@limny.org>
 * @license       GNU/GPL License (http://www.gnu.org/licenses/gpl.html)
 */

require '../incs/form.class.php';

if (isset($_GET['p'][1]) === FALSE)
{
	header('Location: index.php');
	exit;
}

$theme = $_GET['p'][1];

if (in_array($theme, $class['admin']->themes_list()) === FALSE)
{
	header('Location: index.php');
	exit;
}

$class['form'] = new Form;

function update_stylesheet_file($theme, $styles_names, $styles_values)
{
	global $class;
	
	$result = FALSE;
	
	if (count($styles_names) > 0)
	{
		$theme_install = __PATH__ . '/themes/' . $theme . '/install.php';
		if (file_exists($theme_install))
		{
			require_once $theme_install;
			
			$functions = array('stylesheet', 'stylesheet_rtl');
			
			foreach ($functions as $value)
			{
				if (function_exists($value))
				{
					$stylesheet = eval('return ' . $value . '();');
					$stylesheet_file = __PATH__ . '/themes/' . $theme . '/' . $stylesheet['name'];
					
					if (file_exists($stylesheet_file) && is_writable($stylesheet_file))
					{
						$stylesheet['content'] = str_replace($styles_names, $styles_values, $stylesheet['content']);
						file_put_contents($stylesheet_file, $stylesheet['content']);
					}
				}
			}
		}
	}
	
	return $result;
}

if (isset($_POST['update']) && $class['form']->validate_referer())
{
	$error = FALSE;
	
	$styles_names = array();
	$styles_values = array();
	
	$result = $db->select('styles', array('id', 'type', 'name'), array('theme' => '=\'' . $db->escape($theme) . '\''));
	while ($style = $db->fetch_assoc($result))
	{
		if (isset($_POST['styles_' . $style['id']]))
		{
			$value = $_POST['styles_' . $style['id']];
			
			if ($style['type'] == 'CLR')
				$error = preg_match('/^(#)?([0-9a-fA-F]{3})([0-9a-fA-F]{3})?$/', $value) ? FALSE : TRUE;
			else if ($style['type'] == 'NUM')
				$error = is_numeric($value) ? FALSE : TRUE;
			else if ($style['type'] == 'TXT')
				$value = unhtml($value);
			
			if ($error === FALSE)
			{
				array_push($styles_names, '[STYLE=' . $style['name'] . ']');
				array_push($styles_values, $value);
				
				$db->update('styles', array('value' => '\'' . $db->escape($value) . '\''), array('id' => '=\'' . $style['id'] . '\''));
			}
		}
	}
	
	update_stylesheet_file($theme, $styles_names, $styles_values);

	$result = $db->select('images', array('id', 'pattern', 'values', 'image'), array('theme' => '=\'' . $db->escape($theme) . '\'', 'AND', 'pattern' => '!=\'0\''));
	while ($image = $db->fetch_assoc($result))
	{
		$values = unserialize($image['values']);
		$new_values = array();
		
		$pattern_result = $db->select('patterns', array('function', 'variables'), array('id' => '=\'' . $image['pattern'] . '\''));
		$type = ($pattern = $db->fetch_assoc($pattern_result)) ? array_values(unserialize($pattern['variables'])) : NULL;
		
		for ($i = 0; $i < 999; $i++)
		{
			if (isset($_POST[$image['id'] . '_' . $i]))
			{
				$value = $_POST[$image['id'] . '_' . $i];
				
				if ($type[$i] == 'CLR')
					$error = preg_match('/^(#)?([0-9a-fA-F]{3})([0-9a-fA-F]{3})?$/', $value) ? FALSE : TRUE;
				else if ($type[$i] == 'NUM')
					$error = is_numeric($value) ? FALSE : TRUE;
				else if ($type[$i] == 'TXT')
					$value = unhtml($value);
				
				if ($error === FALSE)
					array_push($new_values, $value);
				else
					array_push($new_values, $values[$i]);
			}
			else
			{
				$file = __PATH__ . '/themes/' . $theme . '/images/' . $image['image'];
				if (file_exists($file) && is_writable($file))
				{
					$image_content = eval_this('<?php ' . str_replace('function __pattern', 'function __pattern_' . md5($image['id']), $pattern['function']) . ' ob_start(); __pattern_' . md5($image['id']) . '(array(\'' . implode('\', \'', $new_values) . '\')); $image_content = ob_get_contents(); ob_end_clean(); return $image_content; ?>');
					file_put_contents($file, $image_content);
					$db->update('images', array('values' => '\'' . $db->escape(serialize($new_values)) . '\''), array('id' => '=\'' . $image['id'] . '\''));
				}
				
				break;
			}
		}
	}
	
	$result = $db->select('images', array('id', 'image'), array('theme' => '=\'' . $db->escape($theme) . '\'', 'AND', 'pattern' => '=\'0\''));
	while ($image = $db->fetch_assoc($result))
	{
		if (isset($_FILES[$image['id'] . '_file']))
		{
			$upload_file = $_FILES[$image['id'] . '_file'];
			if (empty($upload_file['name']) === FALSE && $upload_file['size'] > 0)
			{
				$file = __PATH__ . '/themes/' . $theme . '/images/' . $image['image'];
				if (file_exists($file) && is_writable($file))
					file_put_contents($file, file_get_contents($upload_file['tmp_name']));
			}
		}
	}
}

if (isset($_GET['p'][2]) && isset($_POST['default']) && isset($_POST['yes']))
{
	if ($_GET['p'][2] == 'default' && strtoupper($_POST['yes']) == 'YES')
	{
		$styles_names = array();
		$styles_values = array();
		
		$result = $db->select('styles', array('id', 'name', 'default'), array('theme' => '=\'' . $db->escape($theme) . '\''));
		while ($style = $db->fetch_assoc($result))
		{
			array_push($styles_names, '[STYLE=' . $style['name'] . ']');
			array_push($styles_values, $style['default']);
		}
		
		$db->update('styles', array('value' => $db->classifier . 'default' . $db->classifier), array('theme' => '=\'' . $db->escape($theme) . '\''));
		
		update_stylesheet_file($theme, $styles_names, $styles_values);
		
		$db->update('images', array('values' => $db->classifier . 'default' . $db->classifier), array('theme' => '=\'' . $db->escape($theme) . '\'', 'AND', 'pattern' => '!=\'0\''));
		
		$result = $db->select('images', array('id', 'pattern', 'values', 'image', 'default'), array('theme' => '=\'' . $db->escape($theme) . '\''));
		while ($image = $db->fetch_assoc($result))
		{
			$file = __PATH__ . '/themes/' . $theme . '/images/' . $image['image'];
			if (file_exists($file) && is_writable($file))
			{
				if ($image['pattern'] == '0')
					file_put_contents($file, base64_decode($image['default']));
				else
				{
					$values = unserialize($image['values']);
					
					$pattern_result = $db->select('patterns', array('function', 'variables'), array('id' => '=\'' . $image['pattern'] . '\''));
					if ($pattern = $db->fetch_assoc($pattern_result))
					{
						$image_content = eval_this('<?php ' . str_replace('function __pattern', 'function __pattern_' . md5($image['id']), $pattern['function']) . ' ob_start(); __pattern_' . md5($image['id']) . '(array(\'' . implode('\', \'', $values) . '\')); $code = ob_get_contents(); ob_end_clean(); return $code; ?>');
						
						file_put_contents($file, $image_content);
					}
				}
			}
		}
	}
	
	header('Location: index.php?p=styles/' . $_GET['p'][1]);
	exit;
}

$info = $class['admin']->theme_get_info($theme);

$result = $db->select('styles', array('id', 'name', 'type', 'value'), array('theme' => '=\'' . $db->escape($theme) . '\''));
if ($db->num_rows($result) > 0)
{
	$disabled = NULL;
	$styles_writable = TRUE;
	$num = $db->num_rows($result);
	$phrase = ($num == 1) ? OPTION : OPTIONS;
	$styles = '<span class="title">' . STYLES . '</span> <span class="desc">(' . $num . ' ' . $phrase . ')</span>
<div class="table tbl">';
	unset($num);
	
	$theme_install = __PATH__ . '/themes/' . $theme . '/install.php';
	if (file_exists($theme_install))
	{
		require_once $theme_install;
		
		$functions = array('stylesheet', 'stylesheet_rtl');
		
		foreach ($functions as $value)
		{
			if (function_exists($value))
			{
				$stylesheet = eval('return ' . $value . '();');
				
				$stylesheet_file = __PATH__ . '/themes/' . $theme . '/' . $stylesheet['name'];
				if (file_exists($stylesheet_file) && is_writable($stylesheet_file) === FALSE)
				{
					$styles_writable = FALSE;
					$disabled = ' disabled="disabled"';
				}
			}
		}
	}
	
	while ($style = $db->fetch_assoc($result))
	{
		$color = ($style['type'] == 'CLR') ? ' class="color"' : NULL;
		$styles .= '<div class="row"><div class="cell name">' . $style['name'] . ':</div><div class="cell value"><input name="styles_' . $style['id']. '" type="text" value="' . $style['value'] . '"' . $color . $disabled . ' autocomplete="off" /></div></div>';
	}
	
	$styles .= '</div>';
}
else
	$styles = '';

$images = '';
$images_writable = TRUE;

$result = $db->select('images', array('id', 'name', 'pattern', 'values', 'image'), array('theme' => '=\'' . $db->escape($theme) . '\'', 'ORDER BY', 'id' => 'ASC'));
while ($image = $db->fetch_assoc($result))
{
	if ($image['pattern'] == '0')
		$name = FILE;
	else
	{
		$pattern_result = $db->select('patterns', array('name', 'variables'), array('id' => '=\'' . $image['pattern'] . '\''));
		if ($pattern = $db->fetch_assoc($pattern_result))
		{
			$name = $pattern['name'];
			$variables = unserialize($pattern['variables']);
			
			unset($pattern);
		}
	}
	
	$images .= '<span class="title">' . $image['name'] . '</span> <span class="desc">(' . $name . ')</span>
<div class="table tbl">';
	$file = __PATH__ . '/themes/' . $theme . '/images/' . $image['image'];
	
	if (is_writable($file) === FALSE)
	{
		$images_writable = FALSE;
		$disabled = ' disabled="disabled"';
	}
	else
		$disabled = NULL;
	
	if (isset($variables))
	{
		$values = unserialize($image['values']);
		$i = 0;
		
		foreach ($variables as $key => $value)
		{
			$color = ($value == 'CLR') ? ' class="color"' : NULL;
			
			$images .= '<div class="row"><div class="cell name">' . $key . ':</div><div class="cell value"><input name="' . $image['id'] . '_' . $i . '" type="text" value="' . $values[$i] . '"' . $color . $disabled . ' autocomplete="off" /></div></div>';
			$i++;
		}
		
		unset($variables);
	}
	else
		$images .= '<div class="row"><div class="cell name">' . UPLOAD . ':</div><div class="cell value"><input name="' . $image['id'] . '_file" type="file" value=""' .  $disabled . ' /></div></div>';
	
	$images .= '</div>';
}

$message = '';

if (empty($images) === FALSE)
{
	if (extension_loaded('gd') === FALSE || function_exists('gd_info') === FALSE)
		$message .= '<li>' . INFO_36 . '</li>';
	
	if ($images_writable === FALSE)
		$message .= '<li>' . INFO_37 . '</li>';
	
	if ($styles_writable === FALSE)
		$message .= '<li>' . INFO_38 . '</li>';
}

$page['title'] = STYLES . ': ' . $info['name'];

$page['head'] = '<link href="styles.css" type="text/css" rel="stylesheet" />
<link href="table.css" type="text/css" rel="stylesheet" />
<link href="message.css" type="text/css" rel="stylesheet" />
<link href="' . (($class['language']->direction == 'rtl') ? 'rtl/form-rtl.css' : 'form.css') . '" type="text/css" rel="stylesheet" />
<link href="farbtastic.css" type="text/css" rel="stylesheet" />
<script type="text/javascript" src="farbtastic.js"></script>
<script type="text/javascript" src="styles.js"></script>';
$page['content'] = '<a href="index.php?p=appearance"><img src="../misc/appearance-16.png" alt="' . APPEARANCE . '" style="vertical-align:middle;" /> ' . APPEARANCE . '</a> &#8250; ' . STYLES . ': ' . $info['name'] . '<br /><br />' . ((isset($message) && empty($message) === FALSE) ? '<div class="message"><span style="font-weight:bold;">' . INFO_34 . '</span><ul>' . $message . '</ul><span style="color:#555555;">' . INFO_39 . '</span></div>' : NULL) . '<div id="picker"></div><form name="update" action="index.php?p=styles/' . $theme . '" method="post" enctype="multipart/form-data">' . $styles . $images . '<div class="buttons"><input name="update" type="submit" value="' . UPDATE . '"' . ((isset($message) && empty($message) === FALSE) ? ' disabled="disabled"' : NULL) . ' /> &nbsp; <a href="index.php?p=appearance">[' . BACK . ']</a> &nbsp; <a href="index.php?p=styles/' . $_GET['p'][1] . '" class="default" title="' . DEFAULT_VALUES . '"><img alt="' . DEFAULT_VALUES . '" src="../misc/transparent.gif" style="width:32px; height:32px; background: url(../misc/default-32.png) no-repeat center;vertical-align:middle;" /></a></div></form>

<div class="default">
<form name="default" action="index.php?p=styles/' . $_GET['p'][1] . '/default" method="post"><div id="msgbox"></div>
<div id="msgcnt">
	<div style="font-weight: bold;">' . INFO_35 . '</div>
	<div style="text-align: center">' . PLEASE_TYPE_YES_IN_THE_FIELD . ': <input name="yes" type="text" value="" size="5" class="yes" /></div>
	<br />
	<div style="text-align: center;"><input name="default" type="submit" value="' . LOAD_DEFAULT_VALUES . '" /> &nbsp; <a href="#" class="cancel">[' . NOPE . ']</a></div>
</div></form>
</div>';

unset($styles);
unset($images);
unset($theme);
unset($info);

?>