<?php

/*
 * usersroles.tpl
 *
 * @copyright     Copyright 2009-2012 Hamid Reza Samak
 * @link          http://www.limny.org
 * @package       limny
 * @author        Hamid Reza Samak <hamid@limny.org>
 * @license       GNU/GPL License (http://www.gnu.org/licenses/gpl.html)
 */

require '../incs/form.class.php';

$class['form'] = new Form;

if (isset($_POST['role']) && $class['form']->validate_referer())
{
	if (empty($_POST['role']) === FALSE)
	{
		$result = $db->select('roles', array('id'), array('name' => '=\'' . $db->escape($_POST['role']) . '\''));
		if ($db->fetch_assoc($result) === FALSE)
		{
			$role = unhtml($_POST['role']);
			$db->insert('roles', array('name' => $db->escape($role)));
			
			unset($role);
		}
	}
}

unset($class['form']);

$rows = (isset($_GET['p'][1]) && is_numeric($_GET['p'][1]) && $_GET['p'][1] > 0) ? $_GET['p'][1] : 20;
$order = (isset($_GET['p'][3]) && ($_GET['p'][3] == 'asc' || $_GET['p'][3] == 'desc')) ? strtoupper($_GET['p'][3]) : 'ASC';
$sort = array(
	'user' => '',
	'email' => '',
	'role' => '',
	'admin' => '',
	'ban' => ''
);
$sort['default'] = (isset($_GET['p'][2]) && array_key_exists($_GET['p'][2], $sort)) ? strtolower($_GET['p'][2]) : 'user';
$sort[$sort['default']] = ($order == 'ASC') ? ' &#9660;' : ' &#9650;';
$p = (isset($_GET['p'][4]) && is_numeric($_GET['p'][4]) && $_GET['p'][4] > 0) ? $_GET['p'][4] : 1;


$o = ($order == 'ASC') ? 'desc' : 'asc';

$usersroles = '<span class="title user">' . USERS . '</span> &nbsp;-&nbsp; <span class="rows">' . ROWS . ': <input id="r" name="r" type="text" value="' . $rows . '" size="2" /></span>
<div class="users table">
	<div class="row head">
		<div class="cell"><a href="index.php?p=usersroles/' . $rows . '/user/' . $o . '/' . $p . '" style="color: #FFFFFF;">' . USERNAME . $sort['user'] . '</a></div>
		<div class="cell"><a href="index.php?p=usersroles/' . $rows . '/email/' . $o . '/' . $p . '" style="color: #FFFFFF;">' . EMAIL . $sort['email'] . ' </a></div>
		<div class="cell"><a href="index.php?p=usersroles/' . $rows . '/role/' . $o . '/' . $p . '" style="color: #FFFFFF;">' . ROLE . $sort['role'] . '</a></div>
		<div class="cell"><a href="index.php?p=usersroles/' . $rows . '/admin/' . $o . '/' . $p . '" style="color: #FFFFFF;">' . ADMIN . $sort['admin'] . '</a></div>
		<div class="cell"><a href="index.php?p=usersroles/' . $rows . '/ban/' . $o . '/' . $p . '" style="color: #FFFFFF;">' . BAN . $sort['ban'] . '</a></div>
	</div>';
unset($o);

$result = $db->select('users', array('id', 'user', 'email', 'role', 'admin', 'ban'), array('1=1', 'ORDER BY', $sort['default'] => $order, 'LIMIT', (($p - 1) * $rows) . ',' . $rows));
while ($user = $db->fetch_assoc($result))
{
	$role = $class['admin']->role_get_info('name', $user['role']);
	$admin = ($user['admin'] == '1') ? '<span class="green">' . YES . '</span>' : '<span class="red">' . NO . '</span>';
	$ban = ($user['ban'] == '1') ? '<span class="green">' . YES . '</span>' : '<span class="red">' . NO . '</span>';
	
	$usersroles .= '<div id="user_' . $user['id'] . '" class="row body">
	<div class="cell user"><span><a href="index.php?p=user/' . $user['id'] . '">' . $user['user'] . '</a></span> <div class="status edit"></div></div>
	<div class="cell email"><span>' . $user['email'] . '</span> <div class="status edit"></div></div>
	<div class="cell center">' . $role . '</div>
	<div class="cell center admin"><a href="#">' . $admin . '</a></div>
	<div class="cell center ban"><a href="#">' . $ban . '</a></div>
</div>';
}

unset($role);
unset($admin);
unset($ban);

$pages = '';
$result = $db->select('users', array('id'));
if (($db->num_rows($result) / $rows) > 1)
{
	for ($i = 1; $i <= ($db->num_rows($result) / $rows); $i++)
	{
		$pages .= ($i == $p) ? $i . ' ' : '<a href="index.php?p=usersroles/' . $rows . '/user/' . strtolower($order) . '/' . $i . '">' . $i . '</a> ';
		
		if (substr($i, strlen($i) - 1) == 0)
			$pages .= '<br />';
	}
}

unset($rows);

$usersroles .= '</div>
<div class="pages">' . $pages . '</div><form name="addnewrole" action="index.php?p=usersroles" method="post">
<span class="title role">' . ROLES . '</span> &nbsp;-&nbsp; <span><a href="#add" class="addnewrole">' . ADD_NEW_ROLE . '</a></span></form>
<div class="roles table">
	<div class="row head">
		<div class="cell">' . NAME . ' &#9660;</div>
		<div class="cell">' . PERMISSIONS . '</div>
	</div>';

unset($pages);

$result = $db->select('roles', '*', array('1=1', 'ORDER BY', 'name' => ''));
while ($role = $db->fetch_assoc($result))
{
	$count = empty($role['query']) ? 0 : count(explode(',', $role['query']));
	if ($role['query'] == 'all')
		$queries = '<span class="green">' . FULL_PRIVILEGE . '</span>';
	else if ($count > 1)
		$queries = $count . ' ' . PRIVILEGES;
	else if ($count == 1)
		$queries = '1 ' . PRIVILEGE;
	else if ($count == 0)
		$queries = '<span class="red">' . NO_PRIVILEGE . '</span>';
	
	$count = empty($role['admin']) ? 0 : count(explode(',', $role['admin']));
	if ($role['admin'] == 'all')
		$admin = '<span class="green">' . FULL_PRIVILEGE . '</span>';
	else if ($count > 1)
		$admin = $count . ' ' . PRIVILEGES;
	else if ($count == 1)
		$admin = '1 ' . PRIVILEGE;
	else if ($count == 0)
		$admin = '<span class="red">' . NO_PRIVILEGE . '</span>';
	
	$user_result = $db->select('users', array('id'), array('role' => '=\'' . $role['id'] . '\''));
	
	$usersroles .= '<div id="role_' . $role['id'] . '" class="row body">
	<div class="cell role"><span><a href="index.php?p=role/' . $role['id'] . '">' . $role['name'] . '</a> <label class="light">(' . $db->num_rows($user_result) . ')</label></span> <div class="status edit"></div></div>
	<div class="cell privileges"><span><b>' . APPLICATIONS . ':</b> ' . $queries . '</span><br /><br /><span><b>' . ADMINISTRATION . ':</b> ' . $admin . '</span></div>
</div>';
}

$usersroles .= '</div>
<div id="msgbox"></div><div id="msgcnt"><div class="alert"></div><div class="okay"><a href="#" class="okay">[' . OKAY. ']</a></div></div>';
	
$page['title'] = USERS_AND_ROLES;
$page['head'] = '<link href="' . (($class['language']->direction == 'rtl') ? 'rtl/usersroles-rtl.css' : 'usersroles.css') . '" type="text/css" rel="stylesheet" />
<link href="table.css" type="text/css" rel="stylesheet" />
<link href="message.css" type="text/css" rel="stylesheet" />
<script type="text/javascript" src="usersroles.js"></script>
<script type="text/javascript">
$(document).ready(function()
{
$("input#r").keypress(function(event){
	if (event.which == 13)
	{
		location.href= "index.php?p=usersroles/" + $(this).val() + "/' . $sort['default'] . '/' . strtolower($order) . '/' . $p . '";
	}
});
});
</script>';

unset($order);
unset($sort);
unset($p);

$page['content'] = $usersroles;

unset($usersroles);

?>