<?php

/*
 * widget.tpl
 *
 * @copyright     Copyright 2009-2012 Hamid Reza Samak
 * @link          http://www.limny.org
 * @package       limny
 * @author        Hamid Reza Samak <hamid@limny.org>
 * @license       GNU/GPL License (http://www.gnu.org/licenses/gpl.html)
 */

require '../incs/form.class.php';

if (count($_GET['p']) != 3)
{
	header('Location: index.php');
	exit;
}

$class['form'] = new Form;

$result = $db->select('widgets', array('name', 'title', 'content', 'languages', 'roles'), array('position' => '=\'' . $db->escape($_GET['p'][1]) . '\'', 'AND', 'id' => '=\'' . $db->escape($_GET['p'][2]) . '\''));
if ($widget = $db->fetch_assoc($result))
{
	if ($widget['name'] == 'Custom')
	{
		if (isset($_POST['delete']) && isset($_POST['yes']) && $class['form']->validate_referer())
		{
			if (strtoupper($_POST['yes']) == 'YES')
			{
				$db->delete('widgets', array('name' => '=\'Custom\'', 'AND', 'position' => '=\'' . $db->escape($_GET['p'][1]) . '\'', 'AND', 'id' => '=\'' . $_GET['p'][2] . '\''));
				
				header('Location: index.php?p=blocks');
				exit;
			}
		}
		
		$delete = ' &nbsp; <a href="index.php?p=widget/' . $_GET['p'][1] . '/' . $_GET['p'][2] . '/delete" class="delete" title="' . DELETE . '"><img alt="' . DELETE . '" src="../misc/transparent.gif" style="width:32px; height:32px; background: url(../misc/delete-32.png) no-repeat center;vertical-align:middle;" /></a>';
	}
	else
		$delete = '';
	
	require '../incs/role.class.php';
	$class['role'] = new Role;
	
	if (isset($_POST['update']) && $class['form']->validate_referer())
	{
		if (isset($_POST['lang_all']))
			$form['languages'] = 'all';
		else
		{
			$language = $class['language']->languages('value');
			
			$form['languages'] = '';
			foreach ($language as $value)
				if (isset($_POST['lang_' . $value]))
					$form['languages'] .= $value . ',';
			
			$form['languages'] = substr($form['languages'], 0, strlen($form['languages']) - 1);
		}
		
		if (isset($_POST['role_all']))
			$form['roles'] = 'all';
		else
		{
			$role = $class['role']->roles('id');
			
			$form['roles'] = '';
			foreach ($role as $value)
				if (isset($_POST['role_' . $value]))
					$form['roles'] .= $value . ',';
			
			$form['roles'] = substr($form['roles'], 0, strlen($form['roles']) - 1);
		}
		
		$db->update('widgets', array('title' => '\'' . $db->escape(@$_POST['title']) . '\'', 'content' => '\'' . $db->escape(@$_POST['content']) . '\'', 'languages' => '\'' . $form['languages'] . '\'', 'roles' => '\'' . $form['roles'] . '\''), array('position' => '=\'' . $db->escape($_GET['p'][1]) . '\'', 'AND', 'id' => '=\'' . $_GET['p'][2] . '\''));
		
		header('Location: index.php?p=blocks');
		exit;
	}
	
	unset($class['form']);
	
	$languages = '';
	foreach ($class['language']->languages() as $value)
	{
		$checked = in_array($value['value'], explode(',', $widget['languages'])) ? ' checked="checked"' : FALSE;
		$languages .= '<label><input name="lang_' . $value['value'] . '" type="checkbox" value="1"' . $checked . ' />' . $value['name'] . '</label><br />';
	}
	$checked = ($widget['languages'] == 'all') ? ' checked="checked"' : FALSE;
	$languages .= '<label><input name="lang_all" type="checkbox" value="all"' . $checked . ' />' . ALL . '</label>';
	
	$roles = '';
	foreach($class['role']->roles() as $value)
	{
		$checked = in_array($value['id'], explode(',', $widget['roles'])) ? ' checked="checked"' : FALSE;
		$roles .= '<label><input name="role_' . $value['id'] . '" type="checkbox" value="1"' . $checked . ' />' . $value['name'] . '</label><br />';
	}
	$checked = ($widget['roles'] == 'all') ? ' checked="checked"' : FALSE;
	$roles .= '<label><input name="role_all" type="checkbox" value="1"' . $checked . ' />' . ALL . '</label>';
	
	unset($checked);
	
	$page['title'] = WIDGET . ': '. $widget['name'];
	$page['head'] = '<link href="' . (($class['language']->direction == 'rtl') ? 'rtl/form-rtl.css' : 'form.css') . '" type="text/css" rel="stylesheet" />
<link href="message.css" type="text/css" rel="stylesheet" />
<link href="' . (($class['language']->direction == 'rtl') ? 'rtl/widget-rtl.css' : 'widget.css') . '" type="text/css" rel="stylesheet" />
<link href="table.css" type="text/css" rel="stylesheet" />
<script type="text/javascript" src="widget.js"></script>';
	$page['content'] = '<a href="index.php?p=blocks"><img src="../misc/block-16.png" alt="' . BLOCK . '" style="vertical-align:middle;" /> ' . BLOCKS . '</a> &#8250; ' . $widget['name'] . '
<form name="widget" action="" method="post">
<div class="table">
	<div class="row">
		<div class="cell label">' . TITLE . ':</div>
		<div class="cell"><input name="title" type="text" size="50" value="' . str_replace('"', '&quot;', str_replace('<', '&lt;', str_replace('>', '&gt;', $widget['title']))) . '" /></div>
	</div>
	<div class="row">
		<div class="cell label">' . CONTENT . ':</div>
		<div class="cell"><textarea name="content" rows="15" cols="20" style="width:75%;">' . str_replace('"', '&quot;', str_replace('<', '&lt;', str_replace('>', '&gt;', $widget['content']))) . '</textarea></div>
	</div>
	<div class="row">
		<div class="cell label">&nbsp;</div>
		<div class="cell"><fieldset><legend>' . VISIBILITY . '</legend><div class="alignment">' . $languages . '</div><div class="alignment">' . $roles . '</div></fieldset></div>
	</div>
</div>
<div class="buttons"><input name="update" type="submit" value="' . UPDATE . '" /> &nbsp; <a href="index.php?p=blocks">[' . BACK . ']</a>' . $delete . '</div>
</form>

<form name="delete" action="index.php?p=widget/' . $_GET['p'][1] . '/' . $_GET['p'][2] . '" method="post">
<div id="msgbox"></div>
<div id="msgcnt">
	<div style="font-weight: bold;">' . INFO_27 . '</div>
	<br />
	<div style="text-align: center">' . PLEASE_TYPE_YES_IN_THE_FIELD . ': <input name="yes" type="text" value="" size="5" class="yes" /></div>
	<br />
	<div style="text-align: center;"><input name="delete" type="submit" value="' . DELETE . '" /> &nbsp; <a href="#" class="cancel">[' . NOPE . ']</a></div>
</div>
</form>';
}
else
{
	header('Location: index.php?p=blocks');
	exit;
}

?>