<?php

/*
 * widgets.tpl
 *
 * @copyright     Copyright 2009-2012 Hamid Reza Samak
 * @link          http://www.limny.org
 * @package       limny
 * @author        Hamid Reza Samak <hamid@limny.org>
 * @license       GNU/GPL License (http://www.gnu.org/licenses/gpl.html)
 */

if (count($_GET['p']) > 1)
{
	require '../incs/form.class.php';
	$class['form'] = new Form;
	
	if ($class['form']->validate_referer() === FALSE)
	{
		header('Location: index.php?p=widgets');
		exit;
	}
	
	unset($class['form']);
	
	if (isset($_POST['install']) && isset($_FILES['widget']))
	{
		$file = $_FILES['widget'];
		if (empty($file['name']) === FALSE)
		{
			if ($file['size'] > 0)
			{
				$extension = explode('.', $file['name']);
				$extension = end($extension);
				
				if ($extension == 'xml')
				{
					$xml = new DOMDocument();
					$load = @$xml->load($file['tmp_name']);
					
					if ($load === TRUE)
					{
						$nodes = array('limny', 'widget', 'name', 'version', 'compatibility', 'description', 'title', 'content');
						foreach($nodes as $value)
						{
							$x = @$xml->getElementsByTagName($value);
							if ($x === FALSE)
							{
								$message = INFO_46;
								break;
							}
							
							$widget[$value] = @$x->item(0)->nodeValue;
							if ($widget[$value] === FALSE)
							{
								$message = INFO_46;
								break;
							}
						}
						
						$x = @$xml->getElementsByTagName('head');
						$widget['head'] = @$x->item(0)->nodeValue;
						
						unset($x);
						unset($nodes);
						unset($value);
						
						if (isset($message) === FALSE)
						{
							$class['config'] = new Config;
							
							$compatibility = $widget['compatibility'];
							$star = strpos(strtolower($widget['compatibility']), '*');
							
							if (empty($star))
							{
								$compatible = ($compatibility === $class['config']->version) ? TRUE : FALSE;
								unset($star);
							}
							else
							{
								$compatibility = substr($compatibility, 0, $star);
								$limny = substr($class['config']->version, 0, $star);
								
								$compatible = ($compatibility === $limny) ? TRUE : FALSE;
								unset($limny);
							}
							
							unset($star);
							unset($compatibility);
							
							if ($compatible === TRUE)
							{
								$result = $db->select('widnames', array('id'), array('name' => '=\'' . $db->escape($widget['name']) . '\''));
								if ($widgets = $db->fetch_assoc($result))
									$message = INFO_48;
								else
								{
									if ($widget['head'] !== FALSE && empty($widget['head']) === FALSE)
										$db->insert('head', array('app' => 'limny-widget-' . $db->escape($widget['name']), 'eval' => $db->escape($widget['head'], TRUE), 'enabled' => '1'));
									
									$db->insert('widnames', array('name' => $db->escape($widget['name']), 'version' => $db->escape($widget['version']), 'description' => $widget['description']));
									
									$widget['title'] = str_replace(array('&lt;', '&gt;'), array('<', '>'), $widget['title']);
									$widget['content'] = str_replace(array('&lt;', '&gt;'), array('<', '>'), $widget['content']);
									
									$result = $db->select('widgets', array('id'), array('1=1', 'ORDER BY', 'id' => 'DESC'));
									$last = ($last = $db->fetch_assoc($result)) ? $last['id'] : -1;
									
									$db->insert('widgets', array('id' => $last + 1, 'app' => 'limny', 'name' => $db->escape($widget['name']), 'title' => $db->escape($widget['title'], TRUE), 'content' => $db->escape($widget['content'], TRUE), 'position' => 'none', 'languages' => 'all', 'roles' => 'all'));
									
									$message = INFO_49;
									unset($last);
								}
								
								unset($result);
								unset($widget);
							}
							else
								$message = INFO_47;
							
							unset($compatible);
						}
					}
					else
						$message = INFO_45;
					
					unset($load);
					unset($xml);
				}
				else
					$message = INFO_44;
			}
			else
				$message = INFO_43;
		}
		else
			$message = INFO_42;
		
		unset($file);
	}
	else if (isset($_POST['uninstall']))
	{
		if (isset($_GET['p'][2]) && is_numeric($_GET['p'][2]))
		{
			if (isset($_POST['yes']) && strtoupper($_POST['yes']) === 'YES')
			{
				$result = $db->select('widnames', array('name'), array('id' => '=\'' . $db->escape($_GET['p'][2]) . '\''));
				if ($widget = $db->fetch_assoc($result))
				{
					$db->delete('head', array('app' => '=\'limny-widget-' . $db->escape($widget['name']) . '\''));
					$db->delete('widgets', array('app' => '=\'limny\'', 'AND', 'name' => '=\'' . $db->escape($widget['name']) . '\''));
					$db->delete('widnames', array('name' => '=\'' . $db->escape($widget['name']) . '\''));
					
					$message = INFO_52;
				}
				else
					$message = INFO_51;
			}
			else
				$message = INFO_50;
		}
	}
}

$widgets = '';
$result = $db->select('widnames', '*', array('1=1', 'ORDER BY', 'id' => 'ASC')); 
if ($db->num_rows($result) > 0)
{
	$i = 1;
	while ($widget = $db->fetch_array($result))
	{
		$odd_or_even = ($i % 2) ? 'odd' : 'even';
		$widgets .= '<div class="row widget ' . $odd_or_even. '">
		<div class="cell pad name">' . $widget['name'] . ' <span class="light">' . $widget['version'] . '</span><div class="manage"><a href="#' . $widget['id'] . '" class="uninstall" style="color: #EE0000;">[' . UNINSTALL . ']</a></div></div>
		<div class="cell pad desc">' . $widget['description'] . '</div>
	</div>';
			$i++;
		}
		
		unset($i);
		unset($odd_or_even);
		unset($widget);
}
else
	$widgets = '<div class="row widget odd">
	<div class="cell pad name light">' . INFO_40 . '</div>
	<div class="cell pad desc"></div>
</div>';

unset($result);

$class['language'] = new Language;

$page['title'] = WIDGETS;
$page['head'] = '<link href="table.css" type="text/css" rel="stylesheet" />
<link href="' . (($class['language']->direction == 'rtl') ? 'rtl/widgets-rtl.css' : 'widgets.css') . '" type="text/css" rel="stylesheet" />
<link href="' . (($class['language']->direction == 'rtl') ? 'rtl/form-rtl.css' : 'form.css') . '" type="text/css" rel="stylesheet" />
<link href="message.css" type="text/css" rel="stylesheet" />
<script type="text/javascript" src="widgets.js"></script>';

$page['content'] = '<span class="title">' . WIDGETS . '</span>
' . (isset($message) ? '<div class="message">' . $message . '</div>' : NULL) . '
<form name="widget" action="index.php?p=widgets/install" method="post" enctype="multipart/form-data">
<div class="table widgets">
	<div class="row head">
		<div class="cell name">' . NAME . '</div>
		<div class="cell desc">' . DESCRIPTION . '</div>
	</div>
	
	<div class="row">
		<div class="cell subject">- ' . INSTALLED . '</div>
		<div class="cell"></div>
	</div>
	' . $widgets . '
	<div class="row">
		<div class="cell subject">- ' . INSTALL_NEW . '</div>
		<div class="cell"></div>
	</div>
	<div class="row odd">
		<div class="cell pad center"><input name="widget" type="file" value="" /></div>
		<div class="cell pad center"><input name="install" type="submit" value="' . INSTALL . '" /></div>
	</div>
</div>
</form>

<form id="uninstall" name="uninstall" action="index.php?p=widgets/uninstall" method="post">
<div id="msgbox"></div>
<div id="msgcnt">
	<div style="font-weight: bold;">' . INFO_41 . '</div>
	<br />
	<div style="text-align: center">' . PLEASE_TYPE_YES_IN_THE_FIELD . ': <input name="yes" type="text" value="" size="5" class="yes" /></div>
	<br />
	<div style="text-align: center;"><input name="uninstall" type="submit" value="' . UNINSTALL . '" /> &nbsp; <a href="#" class="cancel">[' . NOPE . ']</a></div>
</div>
</form>';

?>