<a href="{url('helloworld')}" style="float:right;">[Back]</a>
<b>Database connection:</b>
<br />
<p style="text-align:justify;">Limny supports four database types (MySQL, PostgreSQL, SQLite, and SQLite3) but we just write a unique syntax for using it.</p>
<br />
<i>Example:</i>
<pre>
PHP Code:
<span style="color:gray;">&lt;?php

// fetching records
// this select method is same as below mysql query
// "SELECT `column1`, `column2`1 FROM `my_table`
// WHERE `column1`='1' AND `column2`='2' ORDER BY `column1` DESC LIMIT 10

$result = $db-&gt;select(
		'my_table', // table as string
		array('column1', 'column2'), // columns as string for '*' or array
		array('column1' =&gt; '=\\'1\\', 'AND', 'column2' =&gt; '=\\'2\\'', 'ORDER BY',
		'column1' =&gt; 'DESC', 'LIMIT 10')
);

while ($record = $db-&gt;fetch_assoc($result))
&#123;
	print $record['column1'] . ' ' . $record['column2'];
&#125;




// insert record
// escape method is used for preventing sql injection attacks
// use it for every string that you get from clients ($_GET & $_POST)

$db-&gt;insert(
	'my_table',
	array('column1' =&gt; $db-&gt;escape('1'), 'column2' =&gt; $db-&gt;escape('2'))
);




// update record
// equivalent: UPDATE `my_table` SET `column1`='5' WHERE `column2`='2'

$db-&gt;update(
	'my_table',
	array('column1' =&gt; '\\'' . $db-&gt;escape('5') . '\\''),
	array('column2' =&gt; '=\\'2\\'')
);




// delete record
// equivalent: DELETE FROM `my_table` WHERE `column2`='2'

$db-&gt;delete('my_table', array('column2' =&gt; '=\\'2\\''));

?&gt;</span>
</pre>
<a href="{url('helloworld/example-database-connection')}" target="_blank">[View]</a> 