<?php

// features function (optional)
// shortcut links which will show below the app name in administration appbar
function features()
{
	// returns string or array
	// in array mode the array key is link name and array value is link address
	return array(
		'Story' => 'index.php?p=app/helloworld',
		'Examples' => 'index.php?p=app/helloworld&q=examples'
	);
}

// install function (optional)
// used for changes before installing app (sometimes creating db tables)
function install()
{
	global $db; // database connection
	
	// creating table => "helloworld"
	// columns => id(int), firstname(varchar), lastname(varchar)
	// auto-increment column => "id"
	// the fourth argument is optional and is used for additional options before semicolon (often for mysql databases)
	$db->create_table('helloworld', array('id' => 'INT NOT NULL', 'firstname' => 'VARCHAR(64) NOT NULL', 'lastname' => 'VARCHAR(64) NOT NULL'), 'id', 'ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1');
	
	// insert into "helloworld" table
	// escape method is used for preventing injection attacks (it is necessary for writing queries)
	$db->insert('helloworld', array('firstname' => $db->escape('Hamid'), 'lastname' => $db->escape('Samak')));
	
	// insert permalink for testing
	$db->insert('permalinks', array( 'app' => 'helloworld', 'query' => 'helloworld/example-permalink', 'permalink' => 'this-is-a-permalink'));
}

// uninstall function (optional)
// rolling back install changes
function uninstall()
{
	global $db;
	
	// deleting record, it is not necessary because we are going to drop table but do it for introducing delete method
	$db->delete('helloworld', array('firstname' => '=\'Samak\''));
	
	// drop "helloworld" table
	$db->drop_table('helloworld');
	
	// delete permalink
	$db->delete('permalinks', array('app' => '=\'helloworld\''));
}

?>