<?php

/*
 * cache.class.php
 *
 * @copyright     Copyright 2009-2012 Hamid Reza Samak
 * @link          http://www.limny.org
 * @package       limny
 * @author        Hamid Reza Samak <hamid@limny.org>
 * @license       GNU/GPL License (http://www.gnu.org/licenses/gpl.html)
 */

class Cache
{
	public $q;
	public $file;
	
	public function is_cached()
	{
		return ($this->cache_exists() && $this->is_alive()) ? TRUE : FALSE;
	}
	
	public function get_cache()
	{
		return unserialize(file_get_contents($this->file));
	}
	
	public function put_cache($page)
	{
		return file_put_contents($this->file, serialize($page));
	}
	
	private function cache_exists()
	{
		$this->file = __PATH__ . '/cache/' . md5($this->q);
		
		return file_exists($this->file) ? TRUE : FALSE;
	}
	
	private function is_alive()
	{
		$class['config'] = new Config;
		
		if (time() - filemtime($this->file) > $class['config']->cache_lifetime)
		{
			unlink($this->file);
			return FALSE;
		}
		
		return TRUE;
	}
}

?>