<?php

/*
 * content.class.php
 *
 * @copyright     Copyright 2009-2012 Hamid Reza Samak
 * @link          http://www.limny.org
 * @package       limny
 * @author        Hamid Reza Samak <hamid@limny.org>
 * @license       GNU/GPL License (http://www.gnu.org/licenses/gpl.html)
 */

class Content
{
	public function make()
	{
		$q = query();
		
		$class['config'] = new Config;
		$config['cache'] = $class['config']->cache;
		
		if ($config['cache'] == '1')
		{
			$class['cache'] = new Cache;
			
			$class['cache']->q = implode('/', $q);
			if ($class['cache']->is_cached())
				return $class['cache']->get_cache();
		}
		
		if (empty($q[0]) === FALSE)
		{
			if ($q[0] == '-' && empty($q[1]) === FALSE)
			{
				if ($this->is_systemic($q[1]))
					$page = $this->sys_to_content($q[1]);
			}
			else
			{
				$class['application'] = new Application;
				
				if ($class['application']->is_installed($q[0]) && $class['application']->is_enabled($q[0]))
					$page = $this->app_to_content($q);
				else
				{
					$q = implode('/', $q);
					$class['permalink'] = new Permalink;
					
					if ($class['permalink']->is_permalink($q))
					{
						if ($class['config']->permalink == 'INCLUDE')
						{
							$result = $class['permalink']->get_query($q);
							$q = explode('/', $result);
							
							if ($class['application']->is_installed($q[0]) && $class['application']->is_enabled($q[0]))
								$page = $this->app_to_content($q);
						}
						else
						{
							header('Location: ' . url($class['permalink']->get_query($q)));
							exit;
						}
					}
				}
			}
		}
		else
			$page = $this->default_content();
		
		if (isset($page) === FALSE)
			return $this->page_not_found();
		
		if ($config['cache'] == '1' && (isset($page['cache']) === FALSE || $page['cache'] === TRUE))
			$class['cache']->put_cache($page);
		
		return $page;
	}
	
	private function sys_to_content($sys)
	{
		global $db;
		
		$result = $db->select('system', array('php', 'tpl'), array('name' => '=\'' . $db->escape($sys) . '\''));
		if ($system = $db->fetch_assoc($result))
		{
			$_tpl = '';
			$content = explode('{', $system['tpl']);
			
			foreach ($content as $value)
			{
				$value = explode('}', $value);
				$_tpl .= (count($value) == 1) ? str_replace(array('\'', '&#123;', '&#125;'), array('\\\'', '{', '}'), $value[0]) : '\' . ' . $value[0] . ' . \'' . str_replace(array('\'', '&#123;', '&#125;'), array('\\\'', '{', '}'), $value[1]);
			}
			
			unset($content);
			
			if (empty($system['php']) === FALSE)
			{
				$code = trim($system['php']);
				$code = substr($code, 5, strlen($code) - 7);
				$code = trim($code);
				
				eval($code);
				
				if (isset($page['content']))
				{
					if (isset($page['template']) === FALSE || (isset($page['template']) && $page['template'] === TRUE))
						$page['content'] .= eval('return \'' . $_tpl . '\';') . "\n";
				}
				else
					$page['content'] = eval('return \'' . $_tpl . '\';') . "\n";
			}
			else
				$page['content'] = eval('return \'' . $_tpl . '\';');
			
			return $page;
		}
		
		return FALSE;
	}
	
	private function is_systemic($name)
	{
		global $db;
		
		$result = $db->select('system', array('name'), array('name' => '=\'' . $db->escape($name) . '\''));
		return ($system = $db->fetch_assoc($result)) ? TRUE : FALSE;
	}
	
	private function app_to_content($q)
	{
		$class['file'] = new File;
		
		if (count($q) < 2)
			$file = 'default';
		else
		{
			$file = str_replace('\\', '', $q[1]);
			if ($q[0] == $file || $q[1] == 'default')
			{
				header('Location: ' . url($q[0]));
				exit;
			}
		}
		
		$app_path = __PATH__ . '/apps/' . $q[0];
		
		$class['language'] = new Language;
		
		$default = $app_path . '/langs/en.php';
		$system = $app_path . '/langs/' . $class['language']->language . '.php';
		
		if (file_exists($system))
			include_once $system;
		else if (file_exists($default))
			include_once $default;
		
		if ($file != 'default' && file_exists($app_path . '/' . $file . '.tpl') === FALSE && file_exists($app_path . '/' . $file . '.php') === FALSE)
			$file = 'default';
		
		if (file_exists($app_path . '/' . $file . '.tpl'))
		{
			$php = $app_path . '/php/' . $file . '.php';
			if (file_exists($php))
				include $php;
			
			$tpl = eval($class['file']->load_template($q[0], $file . '.tpl'));
			
			if (isset($page['content']))
			{
				if (isset($page['template']) === FALSE || (isset($page['template']) && $page['template'] == TRUE))
					$page['content'] .= $tpl . "\n";
			}
			else
				$page['content'] = $tpl . "\n";
		}
		else if (file_exists($app_path . '/' . $file . '.php'))
		{
			ob_start();
			include $app_path . '/' . $file . '.php';
			$ob_contents = ob_get_contents();
			ob_end_clean();
			
			$page['content'] = isset($page['content']) ? $page['content'] . $ob_contents . "\n" : $ob_contents . "\n";
		}
		else
			limny_error('content not found <a href="' . url($q[0]) . '">[Back]</a>');
		
		if (file_exists($app_path . '/style.css'))
		{
			$css = $class['file']->load_style($q[0], 'style.css');
			$page['head'] = isset($page['head']) ? $page['head'] . $css . "\n" : $css . "\n";
		}
		
		if (file_exists($app_path . '/css/' . $file . '.css'))
		{
			$css = $class['file']->load_style($q[0], $file . '.css', '/css');
			$page['head'] = isset($page['head']) ? $page['head'] . $css . "\n" : $css . "\n";
		}
		
		if (file_exists($app_path . '/js/' . $file . '.js'))
		{
			$js = '<script type="text/javascript" src="' . base_path() . '/apps/' . $q[0] . '/js/' . $file . '.js"></script>';
			$page['head'] = isset($page['head']) ? $page['head'] . $js . "\n" : $js . "\n";
		}
		
		return $page;
	}
	
	private function default_content()
	{
		$class['config'] = new Config;
		
		switch($class['config']->content_default)
		{
			case 'app':
				$app = $class['config']->content_app;
				$class['application'] = new Application;
				
				if ($class['application']->is_installed($app) && $class['application']->is_enabled($app))
					$page = $this->app_to_content(array($app));
				else
					return $this->page_not_found();
			break;
			
			case 'query':
				$class['application'] = new Application;
				
				$q = explode('/', $class['config']->content_query);
				if ($class['application']->is_installed($q[0]) && $class['application']->is_enabled($q[0]))
				{
					if ($class['config']->uri_mode == 'REQUEST_URI')
						$_SERVER['REQUEST_URI'] = 'index.php/' . implode('/', $q);
					else
						$_GET['q'] = implode('/', $q);
					
					$page = $this->app_to_content($q);
				}
				else
					return $this->page_not_found();
			break;
			
			case 'code':
				$code = eval_this($class['config']->content_code);
				
				return is_array($code) ? $code : array('content' => $code);
			break;
		}
		
		return $page;
	}
	
	private function page_not_found()
	{
		return array('title' => PAGE_NOT_FOUND, 'content' => PAGE_NOT_FOUND_MESSAGE);
	}
}

?>