<?php

/*
 * file.class.php
 *
 * @copyright     Copyright 2009-2012 Hamid Reza Samak
 * @link          http://www.limny.org
 * @package       limny
 * @author        Hamid Reza Samak <hamid@limny.org>
 * @license       GNU/GPL License (http://www.gnu.org/licenses/gpl.html)
 */

class File
{
	public function get_version($file)
	{
		if (file_exists($file))
		{
			$contents = file_get_contents($file);
			$lines = explode("\n", $contents);
			$info = explode(',', $lines[0]);
			
			return trim($info[1]);
		}
		
		return FALSE;
	}
	
	public function load_style($app, $file, $dir = NULL)
	{
		$class['language'] = new Language;
		
		if ($class['language']->direction == 'rtl')
		{
			$dot_pos = strrpos($file, '.');
			
			if (empty($dot_pos) === FALSE)
				$file = substr($file, 0, $dot_pos) . '-rtl' . substr($file, $dot_pos, strlen($file));
		}
		
		$class['user'] = new User;
		$class['config'] = new Config;
		
		$theme = $class['config']->theme;
		
		if ($class['user']->is_authorized())
		{
			$user_theme = $class['user']->user_get_info('theme');
			
			if (empty($user_theme) === FALSE)
				$theme = $user_theme;
		}
		
		$theme_style = __PATH__ . '/themes/' . $theme . '/' . $app . '-' . $file;
		
		if (file_exists($theme_style))
			$style = base_path() . '/themes/' . $theme . '/' . $app . '-' . $file;
		else
			$style = base_path() . '/apps/' . $app . $dir . '/' . $file;
		
		return '<link rel="stylesheet" href="' . $style . '" type="text/css" />';
	}
	
	public function load_template($app, $file, $dir = NULL)
	{
		$class['user'] = new User;
		$class['config'] = new Config;
		
		$theme = $class['config']->theme;
		
		if ($class['user']->is_authorized())
		{
			$user_theme = $class['user']->user_get_info('theme');
			
			if (empty($user_theme) === FALSE)
				$theme = $user_theme;
		}
		
		$theme_temp = __PATH__ . '/themes/' . $theme . '/' . $app . '-' . $file;
		
		if (file_exists($theme_temp))
			$content = file_get_contents($theme_temp);
		else
			$content = file_get_contents(__PATH__ . '/apps/' . $app . $dir . '/' . $file);
		
		$temp = '';
		$content = explode('{', $content);
		
		foreach ($content as $value)
		{
			$value = explode('}', $value);
			$temp .= (count($value) == 1) ? str_replace(array('\'', '&#123;', '&#125;'), array('\\\'', '{', '}'), $value[0]) : '\' . ' . $value[0] . ' . \'' . str_replace(array('\'', '&#123;', '&#125;'), array('\\\'', '{', '}'), $value[1]);
		}
		
		return 'return \'' . $temp . '\';';
	}
}

?>