<?php

/*
 * form.class.php
 *
 * @copyright     Copyright 2009-2012 Hamid Reza Samak
 * @link          http://www.limny.org
 * @package       limny
 * @author        Hamid Reza Samak <hamid@limny.org>
 * @license       GNU/GPL License (http://www.gnu.org/licenses/gpl.html)
 */

class Form
{
	public function get_domain_name($url)
	{
		$url = explode('/', $url);
		
		if (count($url) < 2)
			return FALSE;
		
		if (preg_match('/^[0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3}$/', $url[2]))
			return $url[2];
		else
		{
			$domain = explode('.', $url[2]);
			$count = count($domain);
			
			return ($count > 1) ? $domain[$count - 2] . '.' . $domain[$count - 1] : $domain[0];
		}
	}
	
	public function validate_referer($address = NULL, $count = 0)
	{
		global $db;
		
		if (isset($_SERVER['HTTP_REFERER']))
			$ref = strtolower($_SERVER['HTTP_REFERER']);
		else
			return FALSE;
		
		if (empty($address))
		{
			$class['config'] = new Config;
			
			$result = $db->select('config', array('value'), array('name' => '=\'site\''));
			$domains = ($config = $db->fetch_assoc($result)) ? explode(',', $config['value']) : array($class['config']->site);
			
			foreach ($domains as $domain)
				if ($this->get_domain_name($domain) == $this->get_domain_name($ref))
					return TRUE;
			
			return FALSE;
		}
		else
		{
			global $db;
			
			$result = $db->select('permalinks', array('permalink'), array('query' => '=\'' . $db->escape($address) . '\''));
			$permalink = ($permalink = $db->fetch_assoc($result)) ? $permalink['permalink'] : FALSE;
			$ref = ($count > 0) ? substr($ref, 0, $count) : $ref;
			
			return ($ref == $address || $ref == url($address, TRUE) || $ref == url($permalink, TRUE)) ? TRUE : FALSE;
		}
	}
}

?>