<?php

/*
 * language.class.php
 *
 * @copyright     Copyright 2009-2012 Hamid Reza Samak
 * @link          http://www.limny.org
 * @package       limny
 * @author        Hamid Reza Samak <hamid@limny.org>
 * @license       GNU/GPL License (http://www.gnu.org/licenses/gpl.html)
 */

class Language
{
	public $language;
	public $direction;
	public $charset;
	
	public function __construct()
	{
		$q = query(TRUE);
		
		if (count($q) > 0)
		{
			if (in_array($q[0], $this->languages('value')))
			{
				$this->language = $q[0];
				$this->charset = $this->language($q[0], 'charset');
				$this->direction = $this->language($q[0], 'direction');
				
				return FALSE;
			}
		}
		
		$class['user'] = new User;
		$class['config'] = new Config;
		
		if ($class['user']->is_authorized() && $class['user']->user_get_info('language') != '')
			$this->language = $class['user']->user_get_info('language');
		else
			$this->language = $class['config']->language;
		
		$this->charset = $this->language($this->language, 'charset');
		$this->direction = $this->language($this->language, 'direction');
	}
	
	public function languages($field = NULL, $arguments = NULL)
	{
		global $db;
		
		$languages = array();
		
		if (empty($field))
		{
			$result = $db->select('languages', '*', $arguments);
			while ($language = $db->fetch_assoc($result))
				array_push($languages, $language);
		}
		else
		{
			$field = $db->escape($field);
			$result = $db->select('languages', array($field), $arguments);
			while ($language = $db->fetch_assoc($result))
				array_push($languages, $language[$field]);
		}
		
		return $languages;
	}
	
	public function language($value, $field)
	{
		global $db;
		
		$result = $db->select('languages', array($field), array('value' => '=\'' . $db->escape($value) . '\''));
		return ($language = $db->fetch_assoc($result)) ? $language[$field] : FALSE;
	}
}

?>