<?php

/*
 * mail.class.php
 *
 * @copyright     Copyright 2009-2012 Hamid Reza Samak
 * @link          http://www.limny.org
 * @package       limny
 * @author        Hamid Reza Samak <hamid@limny.org>
 * @license       GNU/GPL License (http://www.gnu.org/licenses/gpl.html)
 */

class Mail
{
	public $to;
	public $from;
	public $header;
	public $subject;
	public $message;
	
	public function __construct()
	{
		$class['config'] = new Config;
		
		$this->from = $class['config']->email;
		$this->header = array('MIME-Version' => '1.0', 'Content-type' => 'text/html; charset=utf-8');
	}
	
	public function send()
	{
		if (is_array($this->header))
		{
			if (isset($this->header['From']) === FALSE)
				$this->header['From'] = $this->from;
			
			$header = '';
			foreach ($this->header as $key => $value)
				$header .= $key . ': ' . $value . "\r\n";
			
			$this->header = substr($header, 0, strlen($header) - 2);
		}
		
		if (is_array($this->to))
		{
			$to = '';
			foreach ($this->to as $key => $value)
			{
				if (is_numeric($key))
					$to .= $value . ', ';
				else
					$to .= $key . ' <' . $value . '>, ';
			}
			
			$this->to = substr($to, 0, strlen($to) - 2);
		}
		
		return @mail($this->to, $this->subject, $this->message, $this->header);
	}
}

?>