<?php

/*
 * user.class.php
 *
 * @copyright     Copyright 2009-2012 Hamid Reza Samak
 * @link          http://www.limny.org
 * @package       limny
 * @author        Hamid Reza Samak <hamid@limny.org>
 * @license       GNU/GPL License (http://www.gnu.org/licenses/gpl.html)
 */

class User
{
	public function user_get_info($field = '*', $user = NULL)
	{
		global $db;
		
		$user = (empty($user) && $this->is_authorized()) ? $_SESSION['_user'] : $user;
		$result = $db->select('users', ($field == '*' ? '*' : array($field)), array('user' => '=\'' . $db->escape($user) . '\''));
		if ($user = $db->fetch_assoc($result))
			return ($field == '*' || strpos($field, ',') === TRUE) ? $user : $user[$field];
	}
	
	public function is_authorized()
	{
		global $db;
		
		if (isset($_SESSION['_user']) && isset($_SESSION['_pass']))
		{
			$result = $db->select('users', array('id'), array('user' => '=\'' . $db->escape($_SESSION['_user']) . '\'', 'AND', 'pass' => '=\'' . $db->escape($_SESSION['_pass']) . '\''));
			return ($users = $db->fetch_assoc($result)) ? TRUE : FALSE;
		}
		else
		{
			if (isset($_COOKIE['_user']) && isset($_COOKIE['_hash']))
			{
				$result = $db->select('users', array('pass'), array('user' => '=\'' . $db->escape($_COOKIE['_user']) . '\'', 'AND', 'hash' => '=\'' . $db->escape($_COOKIE['_hash']) . '\''));
				if ($users = $db->fetch_assoc($result))
				{
					$_SESSION['_user'] = $db->escape($_COOKIE['_user']);
					$_SESSION['_pass'] = $users['pass'];
					
					return TRUE;
				}
				else
				{
					setcookie('_user', '', time() - 2592000, '/');
					setcookie('_hash', '', time() - 2592000, '/');
				}
			}
		}
		
		return FALSE;
	}
	
	public function user_exists($user, $pass)
	{
		global $db;
		
		$result = $db->select('users', array('id'), array('user' => '=\'' . $db->escape($user) . '\'', 'AND', 'pass' => '=\'' . md5($pass) . '\''));
		return ($users = $db->fetch_assoc($result)) ? TRUE : FALSE;
	}
	
	public function set_login_session($user, $pass, $remember = FALSE)
	{
		global $db;
		
		$_SESSION['_user'] = $user;
		$_SESSION['_pass'] = md5($pass);
		
		if ($remember === TRUE)
		{
			$hash = md5($user . $pass . rand(0, 999));
			
			$db->update('users', array('hash' => '\'' . $db->escape($hash) . '\''), 'WHERE user=\'' . $db->escape($user) . '\'');
			
			setcookie('_user', $user, time() + 2592000, '/');
			setcookie('_hash', $hash, time() + 2592000, '/');
		}
		
		return TRUE;
	}
	
	public function is_banned($user)
	{
		global $db;
		
		$result = $db->select('users', array('ban'), array('user' => '=\'' . $db->escape($user) . '\'', 'AND', 'ban' => '=\'1\''));
		return ($users = $db->fetch_assoc($result)) ? TRUE : FALSE;
	}
}

?>