<!DOCTYPE html>
<html>
<head>
<title>Limny installer</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<style type="text/css">
body {
	margin: 0;
	padding: 0;
	font-size: 10pt;
	font-family: Verdana, Arial, Helvetica, sans-serif;
}

#header {
	width: 100%;
	height: 90px;
	padding-top: 10px;
	border-bottom: 1px solid #DDDDDD;
	background: url(install.png) no-repeat bottom right #EEEEEE;
}

#header ul {
	margin: 0;
	padding: 5px 10px;
	list-style: none;
}

#header ul li {
	color: #333333;
	cursor: default;
	display: inline;
	padding-right: 30px;
}

#header ul li.s {
	font-weight: bold;
	text-decoration: underline;
}

#content {
	width: 40%;
	padding: 0 20px;
}

#buttons {
	padding-top: 30px;
	text-align: right;
}

a img {
	border: 0;
}

input[type=submit] {
	color: #EEEEEE;
	font-size: 12px;
	padding: 2px 20px;
	font-weight: bold;
	border: 1px solid #960000;
	background: url(../misc/button.png) #CD0000;
	font-family: Verdana, Arial, Helvetica, sans-serif;
	border-radius: 12px;
	box-shadow: 0px 0px 10px #DDDDDD;
	-moz-border-radius: 12px;
	-moz-box-shadow: 0px 0px 10px #DDDDDD;
	-webkit-border-radius: 12px;
	-webkit-box-shadow: 0px 0px 10px #DDDDDD;
}

.table {
	display: table;
}

.row {
	display: table-row;
}

.cell {
	min-width: 90px;
	padding: 2px 10px;
	display: table-cell;
}

input[type=text], input[type=password], textarea, select {
	padding: 5px;
	font-size: 14px;
	background: #F7F7F7;
	border: 1px solid #AAAAAA;
	border-radius: 5px;
	-moz-border-radius: 5px;
	-webkit-border-radius: 5px;
	
}

#message {
	color: #222222;
	margin: 10px 0;
	padding: 10px 20px;
	background: #FFFAE4;
	border: 1px solid #E5C530;
	border-radius: 5px;
	-moz-border-radius: 5px;
	-webkit-border-radius: 5px;
}
</style>
<script type="text/javascript">
function updateDisplay(elements, value)
{
	element = elements.split(',');
	
	for (i = 0; i < element.length; i++)
	{
		document.getElementById(element[i]).style.display = value;
	}
}
</script>
</head>
<body>
<div id="header">
	<a href="install.php"><img src="limny.png" alt="Limny" /></a>
	<ul>
		<?php
		
		$s = isset($_GET['s']) ? $_GET['s'] : 1;
		$steps = array(1 => 'Welcome', 'Requirements', 'Configuration', 'Finish');
		foreach ($steps as $key => $value)
			print '<li' . (($s == $key) ? ' class="s"' : NULL) . '>' . $value . '</li>';
		
		?>
	</ul>
</div>
<div id="content">
<?php

function is_submitted()
{
	if (isset($_POST['s']) === FALSE)
	{
		print '<p>You must navigate to steps using forms. Please <a href="install.php">install</a> again.</p></div></body></html>';
		exit;
	}
}

function unhtml($str)
{
	return str_replace(array('&', '<', '>', '"'), array('&amp;', '&lt;', '&gt;', '&quot;'), $str);
}

switch (@$_GET['s'])
{
	default:
		print '<form name="limny" action="install.php?s=2" method="post"><p style="text-align:justify;">Welcome to Limny installation. These pages help you to install and configure Limny in a minute. There are several requirements for installing which are necessary for successful installation. Please go to next step to see requirements.</p><div id="buttons"><input name="next" type="submit" value="Next Step" /></div><input name="s" type="hidden" value="2" /></form>';
	break;
	
	case '2';
		is_submitted();
		
		$true = '<span style="color:green;">&#10004;</span>';
		$false = '<span style="color:red;">&#215;</span>';
		
		$version = FALSE;
		$config = FALSE;
		$current = explode('.', phpversion());
		if (current($current) == 5)
		{
			$version = TRUE;
			$version_status = $true;
		}
		else
			$version_status = $false;
		
		unset($current);
		
		$config_status = $false;
		if (file_exists('../config.php'))
		{
			if (is_writable('../config.php'))
			{
				$config = TRUE;
				$config_status = $true;
			}
		}
		
		print '<form name="limny" action="install.php?s=' . (($version == TRUE && $config == TRUE) ? '3' : '2') . '" method="post"><p style="text-align:justify;">There are several requirements for installing Limny. Please make sure that all of them are available else check them and click on check again button.<ul style="list-style:none;color:#555555;"><li>' . $version_status . ' &nbsp; PHP 5</li><li>' . $config_status . ' &nbsp; Writable configuration file (config.php)</li></ul></p><div id="buttons"><input name="next" type="submit" value="' . (($version == TRUE && $config == TRUE) ? 'Next Step' : 'Check Again') . '" /></div><input name="s" type="hidden" value="3" /></form>';
	break;
	
	case '3':
		is_submitted();
		
		$message = NULL;
		$continue = FALSE;
		
		if (isset($_POST['install']))
		{
			if (in_array($_POST['type'], array('mysql', 'postgresql', 'sqlite', 'sqlite3')) === FALSE)
			{
				header('Location: install.php');
				exit;
			}
			
			require '../incs/' . $_POST['type'] . '.class.php';
			
			if ($_POST['type'] == 'mysql')
			{
				$db = new MySQL;
				
				if ($db->connect($_POST['db_host'], $_POST['db_user'], $_POST['db_pass']))
				{
					if ($db->select_db($_POST['db_name']))
					{
						$db->tbl_prfx = $_POST['db_tblpr'];
						$continue = TRUE;
					}
					else
						$message = '<div id="message">Cannot connect to database. Make sure that database exists.</div>';
				}
				else
					$message = '<div id="message">Cannot connect to host. Please check database <i>hostname</i>, <i>username</i> and <i>password</i>.</div>';
			}
			else if ($_POST['type'] == 'postgresql')
			{
				$db = new PostgreSQL;
				
				if ($db->connect($_POST['db_host'], $_POST['db_user'], $_POST['db_pass'], $_POST['db_name']))
				{
					$db->tbl_prfx = $_POST['db_tblpr'];
					$continue = TRUE;
				}
				else
					$message = '<div id="message">Cannot connect to host or database. Please check <i>hostname</i>, <i>username</i>, <i>password</i> and <i>database</i>.</div>';
			}
			else if ($_POST['type'] == 'sqlite' || $_POST['type'] == 'sqlite3')
			{
				if (file_exists('../' . $_POST['db_file']))
				{
					$MSG_1 = '<div id="message">Cannot open database.</div>';
					$MSG_2 = '<div id="message">Database file is not writable.</div>';
					
					if ($_POST['type'] == 'sqlite')
					{
						$db = new SQLite;
						
						if ($db->open('../' . $_POST['db_file']))
						{
							if (is_writable('../' . $_POST['db_file']))
							{
								$db->tbl_prfx = $_POST['db_tblpr'];
								$continue = TRUE;
							}
							else
								$message = $MSG_2;
						}
						else
							$message = $MSG_1;
					}
					else if ($_POST['type'] == 'sqlite3')
					{
						$db = new SQLiteThree;
						
						if ($db->open('../' . $_POST['db_file']))
						{
							if (is_writable('../' . $_POST['db_file']))
							{
								$db->tbl_prfx = $_POST['db_tblpr'];
								$continue = TRUE;
							}
							else
								$message = $MSG_2;
						}
						else
							$message = $MSG_1;
					}
				}
				else
					$message = '<div id="message">Cannot find database file. Make sure that database file exists.</div>';
			}
			
			if ($continue === TRUE)
			{
				if (empty($_POST['cf_title']) || empty($_POST['cf_header']) || empty($_POST['cf_site']))
				{
					$continue = FALSE;
					$message = '<div id="message">Please fill <i>title</i>, <i>header</i> and <i>site</i> fields.</div>';
				}
			}
			
			if ($continue === TRUE)
			{
				if (empty($_POST['ad_user']) || empty($_POST['ad_pass']) || empty($_POST['ad_email']))
				{
					$continue = FALSE;
					$message = '<div id="message">Please fill administrator <i>username</i> and <i>password</i>.</div>';
				}
			}
			
			if ($continue === TRUE)
			{
				$content = '<?php ' . "\n\n";
				$content .= '$config = array(' . "\n";
				$content .= "\t" . '\'dbs_type\' => \'' . $_POST['type'] . '\',' . "\n";
				
				if (in_array($_POST['type'], array('mysql', 'postgresql')))
				{
					$content .= "\t" . '\'hostname\' => \'' . $_POST['db_host'] . '\',' . "\n";
					$content .= "\t" . '\'username\' => \'' . $_POST['db_user'] . '\',' . "\n";
					$content .= "\t" . '\'password\' => \'' . $_POST['db_pass'] . '\',' . "\n";
					$content .= "\t" . '\'database\' => \'' . $_POST['db_name'] . '\',' . "\n";
				}
				else if (in_array($_POST['type'], array('sqlite', 'sqlite3')))
					$content .= "\t" . '\'database\' => \'' . $_POST['db_file'] . '\',' . "\n";
				
				$content .= "\t" . '\'tbl_prfx\' => \'' . $_POST['db_tblpr'] . '\'' . "\n";
				$content .= ');' . "\n\n";
				$content .= '?>';
				
				file_put_contents('../config.php', $content);
				unset($content);
				
				include 'database.db';
				
				print '<form name="join" action="install.php?s=4" method="post"><p style="text-align:justify;">Limny installed successfully. We recommend you to join in our community to be informed about updates.</p><ul style="list-style:none;"><li><label><input name="join" type="radio" value="yes" checked="checked" /> Yes, I want to be informed about updates</label></li><li><label><input name="join" type="radio" value="no" /> No, thank you</label></li></ul><div id="buttons"><input name="next" type="submit" value="Next Step" /></div><input name="s" type="hidden" value="4" /></form>';
			}
		}
		
		if ($continue === TRUE) print '<div style="display:none;">';
		print '<form name="limny" action="install.php?s=3" method="post">' . ((!$continue) ? $message : NULL) . '<p style="font-weight:bold;">Database</p><div class="table"><div class="row"><div class="cell">Type:</div><div class="cell"><select name="type" onchange="if(this.value == \'mysql\'){ updateDisplay(\'hostname,username,password,database\', \'table-row\'); updateDisplay(\'databasefile\', \'none\'); }else if(this.value == \'postgresql\'){ updateDisplay(\'hostname,username,password,database\', \'table-row\'); updateDisplay(\'databasefile\', \'none\'); }else if(this.value == \'sqlite\' || this.value == \'sqlite3\'){ updateDisplay(\'hostname,username,password,database\', \'none\'); updateDisplay(\'databasefile\', \'table-row\'); }"><option value="mysql"' . (@$_POST['type'] == 'mysql' ? ' selected="selected"' : NULL) . '>MySQL</option><option value="postgresql"' . (@$_POST['type'] == 'postgresql' ? ' selected="selected"' : NULL) . '>PostgreSQL</option><option value="sqlite"' . (@$_POST['type'] == 'sqlite' ? ' selected="selected"' : NULL) . '>SQLite</option><option value="sqlite3"' . (@$_POST['type'] == 'sqlite3' ? ' selected="selected"' : NULL) . '>SQLite3</option></select></div></div><div id="hostname" class="row"' . (@$_POST['type'] == 'sqlite' || @$_POST['type'] == 'sqlite3' ? ' style="display:none;"' : NULL) . '><div class="cell">Hostname:</div><div class="cell"><input name="db_host" type="text" value="' . ((isset($_POST['db_host'])) ? unhtml($_POST['db_host']) : NULL) . '" /></div></div><div id="username" class="row"' . (@$_POST['type'] == 'sqlite' || @$_POST['type'] == 'sqlite3' ? ' style="display:none;"' : NULL) . '><div class="cell">Username:</div><div class="cell"><input name="db_user" type="text" value="' . ((isset($_POST['db_user'])) ? unhtml($_POST['db_user']) : NULL) . '" /></div></div><div id="password" class="row"' . (@$_POST['type'] == 'sqlite' || @$_POST['type'] == 'sqlite3' ? ' style="display:none;"' : NULL) . '><div class="cell">Password:</div><div class="cell"><input name="db_pass" type="password" value="" /></div></div><div id="database" class="row"' . (@$_POST['type'] == 'sqlite' || @$_POST['type'] == 'sqlite3' ? ' style="display:none;"' : NULL) . '><div class="cell">Database:</div><div class="cell"><input name="db_name" type="text" value="' . ((isset($_POST['db_name'])) ? unhtml($_POST['db_name']) : 'limny') . '" /></div></div><div id="databasefile" class="row"' . (@$_POST['type'] == 'sqlite' || @$_POST['type'] == 'sqlite3' ? NULL : ' style="display:none;"') . '><div class="cell">Database File:</div><div class="cell"><input name="db_file" type="text" value="' . ((isset($_POST['db_file'])) ? unhtml($_POST['db_file']) : md5(rand()) . '.sqlite') . '" /></div></div><div class="row"><div class="cell">Table Prefix:</div><div class="cell"><input name="db_tblpr" type="text" value="' . ((isset($_POST['db_tblpr'])) ? unhtml($_POST['db_tblpr']) : 'lmn_') . '" /></div></div></div><br /><p style="font-weight:bold;">Configuration</p><div class="table"><div class="row"><div class="cell">Title:</div><div class="cell"><input name="cf_title" type="text" value="' . ((isset($_POST['cf_title'])) ? unhtml($_POST['cf_title']) : 'My Title') . '" /></div></div><div class="row"><div class="cell">Header:</div><div class="cell"><input name="cf_header" type="text" value="' . ((isset($_POST['cf_header'])) ? unhtml($_POST['cf_header']) : 'My Header') . '" /></div></div><div class="row"><div class="cell">Site:</div><div class="cell"><input name="cf_site" type="text" value="' . ((isset($_POST['cf_site'])) ? unhtml($_POST['cf_site']) : 'http://' . $_SERVER['HTTP_HOST'] . str_replace('/install/install.php', '', $_SERVER['PHP_SELF'])) . '" /></div></div></div><br /><p style="font-weight:bold;">Administrator</p><div class="table"><div class="row"><div class="cell">Username:</div><div class="cell"><input name="ad_user" type="text" value="' . ((isset($_POST['ad_user'])) ? unhtml($_POST['ad_user']) : 'admin') . '" /></div></div><div class="row"><div class="cell">Password:</div><div class="cell"><input name="ad_pass" type="password" value="" /></div></div><div class="row"><div class="cell">Email:</div><div class="cell"><input name="ad_email" type="text" value="' . ((isset($_POST['ad_email'])) ? unhtml($_POST['ad_email']) : NULL) . '" /></div></div></div><div id="buttons"><input name="install" type="submit" value="Install" /></div><input name="s" type="hidden" value="2" /></form>' . (($continue) ? '</div>' : NULL);
	break;
	
	case '4';
		is_submitted();
		
		if (isset($_POST['join']))
			if ($_POST['join'] == 'yes')
				print '<meta http-equiv="refresh" content="0;url=http://www.limny.org/join" />';
		
		print '<p>Thank you for installing Limny.</p><p>Click <a href="http://' . $_SERVER['HTTP_HOST'] . str_replace('/install/install.php', '', $_SERVER['PHP_SELF']) . '">here</a> to go to home page.</p>';
	break;
}

?>
</div>
</body>
</html>